#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Student' => 'Student',
	   'Add' => 'Add',
	   'Category' => 'Category',
	   'New' => 'New',
	   'Description' => 'Description',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'Contact' => 'Contact',
	   'Error' => 'Error',
	   'or' => 'or',
	   'Please Log In' => 'Please Log In',
	   'Contacts' => 'Contacts',
	   'Save' => 'Save',
	   'Date' => 'Date',
	   'No Student Found' => 'No Student Found',
	   'Add Another Record' => 'Add Another Record',

	   );

my $self = 'contactadd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "../ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"../login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

# needed to select only your schools students...
my $select;
if ( $schooldbase ne 'per' ) {
    my $sdb = $dbh->quote( $schooldbase );
    $select = " school = $sdb ";
}


# Print Page Header
print qq{$doctype\n<html><head><title>$lex{Add} $lex{Contacts}</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};

print qq{<link rel="stylesheet" type="text/css" media="all" };
print qq{href="/js/calendar-blue.css" title="blue">\n};
print qq{<script type="text/javascript" src="/js/calendar.js"></script>\n};
print qq{<script type="text/javascript" src="/js/lang/calendar-en.js"></script>\n};
print qq{<script type="text/javascript" src="/js/calendar-setup.js"></script>\n};

print qq{$chartype\n</head><body>\n};

print qq{<div>[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname</div>\n};
print qq{<h1>$lex{Add} $lex{Contacts}</h1>};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    addRecord();
}


#----------------
sub showStartPage {
#----------------

    # Get the students
    if ( $select ) { $select = " where $select"; }
    my $sth = $dbh->prepare("select lastname, firstname, studnum from special 
      $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr;}

    my %students = ();
    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
	$students{"$lastname, $firstname ($studnum)"} = $studnum;
    }

    # Get any categories
    $sth = $dbh->prepare("select distinct category from contactlog
       where category != '' order by category");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr;}
    my @category = ();
    while ( my $category = $sth->fetchrow ) {
	push @category, $category;
    }

    # Start Form.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";


    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Student Selection
    print "<tr><td class=\"bra\">$lex{Student}</td>\n";
    print "<td class=\"la\"><select name=\"student\"><option></option>\n";
    foreach my $key ( sort keys %students ) {
	print "<option value=\"$students{$key}\">$key</option>\n";
    }
    print "</select></td></tr>\n";


    # Category Selection
    print "<tr><td class=\"bra\">$lex{Category}</td>\n";
    print "<td class=\"la\"><select name=\"category\"><option></option>\n";
    foreach my $cat ( @category ) {
	print "<option>$cat</option>\n";
    }
    print "</select> $lex{or}</td></tr>\n";

    # Add New Category
    print "<tr><td class=\"bra\">$lex{New} $lex{Category}</td>\n";
    print "<td class=\"la\">";
    print "<input type=\"text\" name=\"newcategory\" size=\"60\" maxlength=\"255\">\n";
    print "</td></tr>\n";

    # Date Value
    print qq{<tr><td class="bra">$lex{Date}</td><td class="la">};
    print qq{<input type="text" name="date" id="date" size="12">\n};
    print qq{<button type="reset" id="start_trigger">...</button></td></tr>\n};


    # Add New Description
    print "<tr><td class=\"bra\">$lex{Description}</td>\n";
    print "<td align=\"left\">";
    print "<textarea name=\"description\" cols=\"80\" rows=\"4\"></textarea>\n";
    print "</td></tr>\n";

    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Save}\">\n";
    print "</td></tr></table></div>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })\n";

    print "</script>\n";
    print "</body></html>\n";

    exit;

}




#------------
sub addRecord {
#------------

    # foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not $arr{student} ){ # fail
	print "<h1>$lex{'No Student Found'}</h1>\n";
	print "</body></html>\n";
	exit;
    }

    # New Category override
    if ( $arr{newcategory} ) {
	$arr{category} = $arr{newcategory};
    }


    my $sth = $dbh->prepare("insert into contactlog ( studnum, cdate, category, description ) 
     values (?, ?, ?, ?)");
    $sth->execute( $arr{student}, $arr{date}, $arr{category}, $arr{description} );

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Record(s) Stored'}. ".</h3>\n"; 
    } else { 
	print "<h3>$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact} $adminname  <a href=\"mailto:$adminemail\">$adminemail</a></h3>\n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">$lex{'Add Another Record'}</a> ]\n";
    print "</body></html>\n";

    exit;

};
