#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Evaluation Master Entry' => 'Evaluation Master Entry',
	   'Category' => 'Category',
	   'School' => 'School',	   
	   'Main' => 'Main',
	   'Objective' => 'Objective',
	   'Objectives' => 'Objectives',
	   'Add' => 'Add',
	   'Please select the student and goals' => 
	     'Please select the student and goals',
	   'Select Student' => 'Select Student',
	   'Save' => 'Save',
	   'Strategies, Resources and Activities' => 'Strategies, Resources and Activities',
	   'Responsible Person(s)' => 'Responsible Person(s)',
	   'Long Term Objective' => 'Long Term Objective',
	   'Note' => 'Note',
	   'Mastery' => 'Mastery',
	   'Term' => 'Term',	   
	   'Select' => 'Select',
	   'Entry Error: No student selected or &gt; 32 goals selected.' =>
	     'Entry Error: No student selected or &gt; 32 goals selected.',
	   'Add More' => 'Add More',
	   'Record Stored' => 'Record Stored',
	   'Record Updated' => 'Record Update',

	   'Mastery' => 'Mastery',
	   'Please Log In' => 'Please Log In',
	   'Strategy' => 'Strategy',
	   'Target Skill' => 'Target Skill',
	   'Current Performance Level' => 'Current Performance Level',
	   'Evaluation Method' => 'Evaluation Method',

	   'Goal' => 'Goal',
	   'Goals' => 'Goals',
	   'Continue' => 'Continue',
	   'Impacts' => 'Impacts',
	   
	   
	   );

my $self = 'evmstAdd.pl';

my $staffnumber = 5; # number of entries for a staff userid and responsibility


use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    
    print $q->header( -charset, $charset );
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></body></html>\n};
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;


# Load Configuration Vals
my $sth = $dbh->prepare("select id, datavalue from conf_system where dataname = ?");
foreach my $field ( qw(g_ImpactArea g_Impact g_ImpactValue) ) {
    $sth->execute( $field );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ($id, $datavalue) = $sth->fetchrow ) {
	eval $datavalue;
	if ( $@ ) {
	    print "$lex{Error}: $@<br>\n";
	    die "$lex{Error}: $@\n";
	}
    }
}


# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Heading
my $title = "Add Student Goals";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head>\n};
print qq{<body>[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname\n};

#print qq{<form action="objectiveadd.pl" method="post" style="display:inline;">\n};
#print qq{<input type="submit" value="Add New Goals">\n};
#print qq{</form>\n};

print qq{<h1>$title</h1>\n};

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectGoalGroups();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    selectGoals();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    selectMastery();
    
} elsif ( $arr{page} == 4 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub selectMastery {  # and staff
#----------------

#    print qq{Select Mastery<br>\n};
#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # clean up studnum and terms for mastery
    my $studnum = $arr{studnum};
    delete $arr{studnum};
    
    my $terms = $arr{terms};
    delete $arr{terms};
    if ( not $terms ) {
	print qq{<h3>Terms Missing</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    # Read in the student record, get name.
    my $sth = $dbh->prepare("select lastname, firstname from special where school = $sdb and studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    if ( not $lastname ) {
	print qq{<h3>Student Not Found</h3>\n};
	print qq{</body></html>\n};
	exit;
    }


    my (%cat, %per, %goal ); 
    # %cat stores 4 fields for each category, %per stores any personal goals typed, %goal are ones with idnums
        
    # Extract all other passed values
    foreach my $key ( sort keys %arr ) {
	my ( $catnum, $field ) = split(':', $key );
	
	if ( $field =~ m/PER/ ) { # a personal goal field of teacher.
	    if ( not $arr{$key} ) { next; }
	    $field =~ s/PER-//g; # strip leader, leaving the digit.
	    $per{$catnum}{$field} = $arr{$key};
	    
	} elsif ( $field =~ m/\d/ ) { # if a digit it is a system goal with an idnum.
	    $goal{$catnum}{$field} = 1;
	    
	} else { # left with only one of the 4 fields in cat (main)
#	    print "CATNUM:$catnum FIELD:$field VAL:$arr{$key}<br>\n";
	    $cat{$catnum}{$field} = $arr{$key};
	}
    }

=head    
    # View the 2 hashes
    foreach my $catnum ( sort keys %goal ) {
	foreach my $field ( sort keys %{ $goal{$catnum}} ) {
	    print "Goal $catnum - $field - $goal{$catnum}{$field}<br>\n";
	}
    }

    foreach my $catnum ( sort keys %per ) {
	foreach my $field ( sort keys %{ $per{$catnum}} ) {
	    print "Personal Goal $catnum - $field - $per{$catnum}{$field}<br>\n";
	}
    }

    foreach my $catnum ( sort keys %cat ) {
	foreach my $field ( sort keys %{ $cat{$catnum}} ) {
	    print "Main  $catnum - $field - $cat{$catnum}{$field}<br>\n";
	}
    }
=cut
    
    
   
    # Add/Update the 4 fields in %cat
    my $sth = $dbh->prepare("select id from evmst_main where catnum = ? and studnum = ?");
    my $sth1 = $dbh->prepare("insert into evmst_main ( catnum, studnum ) values (?,?)");
    
    foreach my $catnum ( keys %cat ) {

	# Do we have a current mainid record?
	$sth->execute( $catnum, $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $mainid = $sth->fetchrow;
#	print "Studnum:$studnum CATNUM:$catnum MainID:$mainid<br>\n";
	
	if ( not $mainid ) {  # if not a record, then add it and get the mainid.
	    $sth1->execute( $catnum, $studnum );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	    # Get the ID of the newly added table.
	    $sth->execute( $catnum, $studnum );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    $mainid = $sth->fetchrow;

	}
	
	# now update the 4 fields
	foreach my $field ( keys %{ $cat{$catnum}} ) {
#	    print "Field:$field VAL:$cat{$catnum}{$field} MainID:$mainid<br>\n";
	    my $sth2 = $dbh->prepare("update evmst_main set $field = ? where id = ?");
	    $sth2->execute( $cat{$catnum}{$field}, $mainid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }


    # Delete these from %arr;
    foreach my $catnum ( sort keys %cat ) {
	foreach my $field ( sort keys %{ $cat{$catnum}} ) {
	    my $key = "$catnum:$field";
	    delete $arr{$key};
	}
    }
 
#    print "<br><br>\n";

#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    

    # Now do the Team Members Roles and then Mastery Levels for all goals
    
    # Form Start
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="4">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};

    
    # Pass all %arr values through to next page.
    foreach my $key (sort keys %arr ) {
	print qq{<input type="hidden" name="$key" value="$arr{$key}">\n};
    }

 
    foreach my $catnum ( keys %cat ) {

	# Now find name for entered category group
	$sth = $dbh->prepare("select category from subject where catnum = ?");
	$sth->execute( $catnum );
	if ($DBI::errstr) { print $DBI::errstr; die;}    
	my $category = $sth->fetchrow;

   
	# Load the system stored goals for this catnum;
	my %objectives;
	my $sth = $dbh->prepare("select idnum, description from subject where catnum = ? order by idnum");
	$sth->execute( $catnum );
	if ($DBI::errstr) { print $DBI::errstr; die;}    
	while ( my ($idnum, $desc ) = $sth->fetchrow ) {
	    $objectives{$idnum} = $desc;
	}
    
	my (%team, %teamsort);

	# Get Team name, userid, title
	my $sth = $dbh->prepare("select lastname, firstname, userid, jobtitle from team where studnum = ?");
	$sth->execute( $studnum) ;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    
	while ( my ($lastname, $firstname, $userid, $jobtitle ) = $sth->fetchrow ) {

	    $teamsort{"$lastname$firstname$userid"} = $userid;
	    
	    $team{$userid}{name} = "$lastname, $firstname";
	    $team{$userid}{jobtitle} = $jobtitle;
	}

	#    foreach my $userid ( @team ) {
	#	print "$team{$userid}{'name'} - $team{$userid}{'position'}<br>\n";
	#    }

	print qq{<h2>$category $lex{Goals} - $firstname $lastname</h2>\n};
    
	print qq{<p><input type="submit" value="$lex{Save}"></p>\n};
    
	print qq{<table cellpadding="10" cellspacing="0" border="1" style="margin-bottom:2em;">\n};
	print qq{<tr><th>Goal</th><th>Mastery</th>\n};
    
	# Display the passed idnum values and get mastery level for each term.
	foreach my $key ( sort keys %{ $goal{$catnum}} ) {

	    print qq{<tr><td style="vertical-align:top;" class="la">};
	    print qq{<b>$key</b>. $objectives{$key}</td><td class="la">};
	    foreach my $term ( 1..$terms ) {
		print qq{Term $term };
		print qq{<select name="$catnum:M-$key:$term"><option></option>\n};
		foreach my $mst ( @g_mastery ) {
		    print qq{<option>$mst</option>};
		}
		print qq{</select><br>\n};
	    }
	    print qq{</td>\n};
	}
	
	# Now do the personal goal sections
	foreach my $key ( sort keys %{ $per{$catnum}} ) {
	    
	    print qq{<tr><td style="vertical-align:top;" class="la">};
	    print qq{<b>Personal Goal $key</b>. $per{$catnum}{$key}</td><td>};
	    foreach my $term ( 1..$terms ) {
		print qq{Term $term };
		print qq{<select name="$catnum:P-$key:$term"><option></option>\n};
		foreach my $mst ( @g_mastery ) {
		    print qq{<option>$mst</option>};
		}
		print qq{</select><br>\n};
	    }
	    print qq{</td>\n};
	}

	print qq{</table>\n};

    
	# Enter values for team members and their responsbility
	print qq{<table cellpadding="10" cellspacing="0" border="1">\n};
	print qq{<tr><th>Team Member</th><th>Responsibility & Strategy</th></tr>\n};

	# Check for existing values and display any (this catnum, student).
	my $sth7 = $dbh->prepare("select userid, strategy from evmst_staff where mainid = ?");
	
	my $sth6 = $dbh->prepare("select id from evmst_main where studnum = ? and catnum = ?");
	$sth6->execute( $catnum, $studnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $mainid = $sth6->fetchrow ) {
	    $sth7->execute( $mainid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    while ( my ( $userid, $strategy ) = $sth7->fetchrow ) {
		print qq{<tr><td>$team{$userid}{'name'} ($team{$userid}{jobtitle}) $userid</td>\n};
		print qq{<td class="la">$strategy</td></tr>\n};
	    }
	}

	for my $idx (1..$staffnumber) {  # staffnumber set at top of script, controls number of entries made
	    print qq{<tr><td style="vertical-align:top;"><select name="$catnum:staff-$idx"><option></option>\n};
	    foreach my $key ( sort keys %teamsort ) {
		my $userid = $teamsort{$key};
		print qq{<option value="$userid">$team{$userid}{'name'} - $team{$userid}{jobtitle}</option>\n};
	    }
	    print qq{</select></td>\n};
	
	    print qq{<td><textarea name="$catnum:resp-$idx" rows="4" cols="100"></textarea></td></tr>\n};
	}
	print qq{</table><p></p>\n};

	print qq{<p><input type="submit" value="$lex{Save}"></p>\n};

    } # end of category loop

    print qq{</form></body></html>\n};

    exit;

} # End of selectMastery



#----------------
sub showStartPage {
#----------------

    # Start the form.
    # print qq{<form action="$self" method="post">\n};
    # print qq{<input type="hidden" name="page" value="1">\n};
    # print qq{<input type="submit" value="$lex{Continue}">\n};

    
    # Load impacts for this student
    my $sth1 = $dbh->prepare("select * from impact_stud where studnum = ?");

    # Load Goals
    my $sth2 = $dbh->prepare("select id, catnum from evmst_main where studnum = ?");

    # Count the goals in this goal group
    my $sth3 = $dbh->prepare("select count(*) from evmst_goal where mainid = ?");

    my $sth4 = $dbh->prepare("select category from subject where catnum = ?");
    

    
   
    # Read in all special students from this school and put in array
    my $sth = $dbh->prepare("select lastname, firstname, studnum, designation from special 
     $select order by lastname, firstname");  # $select set above for the school
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    my $counter = 1;
    my $first = 1;
    while ( my ( $lastname, $firstname, $studnum, $designation ) = $sth->fetchrow ) {

	# strip code
	$designation =~ s/\([a-zA-Z]+\)//g;

	
	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	    print qq{<tr><th>$lex{'Select Student'}</th><th>Impacts</th><th>Goals</th></tr>\n};
	    $first = 0;
	}

	# Load impacts
	my %imp;
	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $ref = $sth1->fetchrow_hashref ) {
	    my %r = %$ref;
	    if ( $r{impact} ) {
		$imp{$r{impact}} = $r{val};
	    } elsif ( $r{other} ) { # it must be an 'other' value.
		$imp{$r{other}} = $r{val};
	    } else { # an error;
		print qq{<h3>$lex{Error}: Empty Impact for $firstname $lastname ID:$r{id}</h3>\n};
	    }
	}


	my (%goals, %gsort);
	# Get main Id.
	$sth2->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($mainid, $catnum) = $sth2->fetchrow ) {

	    # Get the Category (ie. Goal Group Name)
	    $sth4->execute( $catnum );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my $category = $sth4->fetchrow;

	    # Count the goals in this group
	    $sth3->execute( $mainid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my $goalcount = $sth3->fetchrow;

	    # Put into the hash
	    $goals{$catnum}{count} = $goalcount;
	    $goals{$catnum}{name} = $category;
	    $gsort{"$category$catnum"} = $catnum;

	}
	    
	# Form Start for this student
	print qq{<tr><td>$counter. \n};
	print qq{<form action="$self" method="post" style="display:inline;">\n};
	print qq{<input type="hidden" name="page" value="1">\n};
	print qq{<input type="hidden" name="studnum" value="$studnum">\n};
	print qq{<input type="submit" value="$firstname $lastname ($studnum)"></form>\n};
	print qq{<div style="padding:0.3em;">$designation</div></td>};
	$counter++;

	print qq{\n<td  style="vertical-align:top;">};

	# Display Impacts.
	foreach my $impact ( sort keys %imp ) {
	    print qq{<div><b>$impact</b> - $g_ImpactValue{$imp{$impact}}</div>\n};
	}
	print qq{</td><td style="vertical-align:top;">\n\n};

	# Display Goals
	foreach my $key ( sort keys %gsort ) {
	    my $catnum = $gsort{$key};
	    print qq{<div><b>$goals{$catnum}{name}</b> - $goals{$catnum}{count}</div>\n};
	}
	print qq{</td></tr>\n\n};


	
    }

    
    if ( $first ) {
	print qq{</form>\n};
	print qq{<h3>No Students Found</h3>\n};
	print qq{</body></html>\n};
	exit;
	
    } else {
	print qq{</table>\n};
    }


    # print qq{<input type="submit" value="$lex{Continue}">\n};
    # print qq{</form>\n};
    
    print qq{</body></html>\n};

    exit;

} # End of showStartPage


	  
#-------------------
sub selectGoalGroups {
#-------------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my $studnum = $arr{studnum};
    delete $arr{studnum};

    # Get the evaluation master counts by catnum (category number or goal groups) ie. 606 Reading
    my (%usedgroup, %topgroup, %middlegroup);
    my $sth = $dbh->prepare("select catnum, count(catnum) from evmst_main group by catnum 
      order by count(catnum) desc");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my (@goalgroup, $counter);
    while ( my ($catnum, $count ) = $sth->fetchrow ) {
	push @goalgroup, $catnum;
	$usedgroup{$catnum} = $count;
	$counter++;
	if ( $counter <= 20) {
	    $topgroup{$catnum} = $count;
	} else {
	    $middlegroup{$catnum} = $count;
	}
    }

    # Get all groups of goals.
    my @allcatnum;
    my $sth = $dbh->prepare("select distinct catnum from subject");  # unsorted
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $catnum = $sth->fetchrow ) {
	push @allcatnum, $catnum;
    }


    # Get the text descriptions for each of the goal groups;
    my %catdesc;
    my $sth = $dbh->prepare("select distinct catnum, category from subject");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $catnum, $category ) = $sth->fetchrow ) {
	$catdesc{$catnum} = $category;
    }


    # Create the unused groups list
    my %unused;
    foreach my $catnum ( @allcatnum ) {
	if ( $usedgroup{$catnum} ) { next; }
	$unused{"$catdesc{$catnum} ($catnum)"} = $catnum;
    }
    
    
    # Start the Form
    print qq{<form action="$self" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};
    
    # Get student name.
    my $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    print qq{<h3>$firstname $lastname ($studnum)</h3>\n};
    

    # Load their impacts
    my $sth1 = $dbh->prepare("select * from impact_stud where studnum = ?");
    my %imp;
    $sth1->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $ref = $sth1->fetchrow_hashref ) {
	my %r = %$ref;
	if ( $r{impact} ) {
	    $imp{$r{impact}} = $r{val};
	} elsif ( $r{other} ) { # it must be an 'other' value.
	    $imp{$r{other30}} = $r{val};
	} else { # an error;
	    print qq{<h3>Error: Empty Impact for $firstname $lastname ID:$r{id}</h3>\n};
	}
    }

    
    # Display the Impacts, if any
    my $first = 1;
    foreach my $imp ( keys %imp ) {

	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="1">};
	    # print qq{style="position:absolute;top:5px;right:5px;">\n};
	    print qq{<tr><th>Impacts</th></tr>\n};
	    $first = 0;
	}

	print qq{<tr><td>$imp</td></tr>\n};

    }

    if ( not $first ) {
	print qq{</table>\n};
    } else { # no impacts
	print qq{<h3 style="color:red;">No Impacts Found</h3>\n};
    }

    
    print qq{<h3>Select Goal Groups <br><span style="font-size:60%;">};
    print qq{Sorted from most popular to least popular</span></h3>\n};


    # Write My Own
    print qq{<div style="font-weight:bold;font-size:120%;"><input type="checkbox" name="writemyown" value="1"> };
    print qq{I want to write all of my own goals!</div>\n};
    

    # Setup the Topgroup, first sort
    my %topsort;
    foreach my $catnum ( sort keys %topgroup ) {
	$topsort{"$catdesc{$catnum}$catnum"} = $catnum;
    }

    print qq{<hr><table cellpadding="10" cellspacing="0" border="1" style="margin-bottom:1em;">\n};
    print qq{<tr><th>The Top 20</th><th>#Chosen</th></tr>\n};
    
    my $counter = 1;
    foreach my $key ( sort keys %topsort ) {
	my $catnum = $topsort{$key};
	print qq{<tr><td>$counter. <input type="checkbox" name="$catnum" value="1">};
	print qq{$catdesc{$catnum} ($catnum)</td>\n};
	print qq{<td>$topgroup{$catnum}</td></tr>\n};
	$counter++;
    }

    
    print qq{</table>\n};
    print qq{<input type="submit" value="Continue">\n};
    print qq{<hr>\n};

    # Now do the middle group
    print qq{<table cellpadding="10" cellspacing="0" border="1" style="margin-bottom:1em;">\n};
    print qq{<tr><th>The Rest</th><th>#Chosen</th></tr>\n};
   
    my %midsort;
    foreach my $catnum ( sort keys %middlegroup ) {
	$midsort{"$catdesc{$catnum}$catnum"} = $catnum;
    }

    my $counter = 1;
    foreach my $key ( sort keys %midsort ) {
	my $catnum = $midsort{$key};
	print qq{<tr><td>$counter. <input type="checkbox" name="$catnum" value="1">};
	print qq{$catdesc{$catnum} ($catnum)</td>\n};
	print qq{<td>$middlegroup{$catnum}</td></tr>\n};
	$counter++;
    }

    print qq{</table>\n};
    
=head    
    foreach my $count (1..4) {
	print qq{<div style="padding:0.4em;">$count. <select name="$count:catnum"><option></option>\n};
	foreach my $catnum ( @goalgroup ) {
	    print qq{<option value="$catnum">$catdesc{$catnum} ($catnum)</option>};
	}
	print qq{</select></div>\n};
    }
=cut


    # Unused Groups
    print qq{<h3>Unused Groups</h3>\n};
    print qq{<div><select name="unused"><option></option>\n};
    foreach my $key ( sort keys %unused ) {
	my $catnum = $unused{$key};
	print qq{<option value="$catnum">$key</option>};
    }
    print qq{</select></div>\n};

    print qq{<input type="submit" value="Continue">\n};
    print qq{</form></body></html>\n};

    exit;

} # End of selectGoalGroups



#--------------
sub selectGoals {
#--------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    # Passed: studnum, catnum (goal group), and unused.
    
    my $studnum = $arr{studnum};
    delete $arr{studnum};
    
    my $unused = $arr{unused};
    delete $arr{unused};


    my $writemyown = $arr{writemyown};
    delete $arr{writemyown};
    
     # The rest should be catnum's.


    my %catnum;
=head     
    foreach my $count (1..4) {
	my $key = "$count:catnum";
	if ( $arr{$key} ) {
	    $catnum{$arr{$key}} = 1;
	}
    }
=cut    

     my %catnum = %arr;
     
    if ( $unused ) {
	$catnum{$unused} = 1;
    }
    

    if ( not %catnum ) {
	print qq{<h3 style="color:red;">No Goal Group found</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    
    # foreach my $key ( sort keys %catnum ) { print "K:$key V:$catnum{$key}<br>\n";  }
     
    
    my $sth4 = $dbh->prepare("select category from subject where catnum = ?");
    my $sth5 = $dbh->prepare("select description, idnum from evmst_goal where mainid = ?");

    my $first = 1;
    # Display Current Goal Groups
    my $sth = $dbh->prepare("select * from evmst_main where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die; }
    
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;

	if ( $first ) { # start the table
	    print qq{<hr><table cellpadding="10" cellspacing="0" border="1" style="margin-bottom:1em;">\n};
	    print qq{<tr><th colspan="2">Current Goal Groups</th><th>Goals</th></tr>\n};
	    $first = 0;
	}

	# Get the Description
	$sth4->execute( $r{catnum} );
	if ($DBI::errstr) { print $DBI::errstr; die;}    
	my $category = $sth4->fetchrow;

#	print qq{CAT:$r{catnum} MainID:$r{id}<br>\n};

	if ( $catnum{ $r{catnum} } ) { # we already have a record
	    $catnum{ $r{catnum} } = $r{id}; # replace the '1' value with record id number.
	}

	
	# Get the Desc and IDNUM's for goals
	my @goals;
	$sth5->execute( $r{id} );
	if ($DBI::errstr) { print $DBI::errstr; die;}
	while ( my ($desc,$idnum) = $sth5->fetchrow ) {
	    push @goals, qq{$desc (ID:$idnum)};
	}
	my $goalvalues = join('<br>',@goals);
	
	if ( $r{catnum} eq $catnum ) {
	    %em = %r;
	    $em{category} = $category;
	}
	
	print qq{<tr><td>$category</td><td>$r{catnum}</td><td>$goalvalues</td></tr>\n};
	
    }

    if ( not $first ) { print qq{</table>\n}; }
   

    print qq{<hr>\n};



    # New Form Entry Start
    
    # Read in the student name, and make sure present.
    my $sth = $dbh->prepare("select lastname, firstname from special where school = $sdb and studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    if ( not $lastname ) {
	print qq{<h3>Student Not Found</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    
    # Form Start
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="3">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};    
    
    print qq{<div>Number of Terms - Mastery <input style="width:4em;" type="text" name="terms" value="4"></div>\n};

   
    my $sth = $dbh->prepare("select * from evmst_main where studnum = ? and catnum = ?");
    
    
    # Loop through all the category numbers.
    foreach my $catnum ( keys %catnum ) {

	$sth4->execute( $catnum );
	if ($DBI::errstr) { print $DBI::errstr; die; }
	my $category = $sth4->fetchrow;
	
	my ($mainid, %em);
	if ( $catnum{$catnum} > 1 ) { # we have a current record in evmst_main for goal group
	    $mainid = $catnum{$catnum};
	    
	    $sth->execute( $studnum, $catnum );
	    if ($DBI::errstr) { print $DBI::errstr; die; }
	    my $ref = $sth->fetchrow_hashref;
	    %em = %$ref;
	}
  
	# Load the objectives for this catnum;
	my %objectives;

	if ( not $writemyown ) {
	    my $sth1 = $dbh->prepare("select idnum, description from subject where catnum = ? order by idnum");
	    $sth1->execute( $catnum );
	    if ($DBI::errstr) { print $DBI::errstr; die;}    
	    while ( my ($idnum, $desc ) = $sth1->fetchrow ) {
		$objectives{$idnum} = $desc;
	    }

	    # Check for objectives to skip, since already used.
	    my %skip;
	    if ( $mainid ) { # load existing goals (to skip).
		my $sth2 = $dbh->prepare("select idnum from evmst_goal where mainid = ?");
		$sth2->execute( $mainid );
		if ($DBI::errstr) { print $DBI::errstr; die;}    
		while ( my $idnum = $sth2->fetchrow ) {
		    $skip{$idnum} = 1
		}
	    }
	}

	# Section subject specific stuff.
	# Now print goals
	print qq{<table cellpadding="10" cellspacing="0" border="1">\n};    
	print qq{<tr><th>$lex{Select} $lex{Objective}</th></tr>\n};
	
	print qq{<h2>$category $lex{Goals} - $firstname $lastname</h2>\n};
	print qq{<p><input type="submit" value="$lex{Continue}"></p>\n};
    
	print qq{<table cellpadding="10" cellspacing="0" border="1" style="margin-bottom:1em;">\n};    
	print qq{<tr><td class="bla">$lex{'Target Skill'}<br>\n};
	print qq{<textarea name="$catnum:targetskill" rows="4" cols="100">$em{targetskill}</textarea></td></tr>\n};

	print qq{<tr><td class="bla">$lex{'Current Performance Level'}<br>\n};
	print qq{<textarea name="$catnum:currperform" rows="4" cols="100">$em{currperform}</textarea></td></tr>\n};
	
	print qq{<tr><td class="bla">$lex{'Evaluation Method'}<br>\n};
	print qq{<textarea name="$catnum:evalmethod" rows="4" cols="100">$em{evalmethod}</textarea></td></tr>\n};

	print qq{<tr><td class="bla">$lex{'Long Term Objective'}<br>\n};
	print qq{<textarea name="$catnum:longtermobjective" rows="4" cols="100">$em{longtermobjective}</textarea>};
	print qq{</td></tr>\n};

	
	print qq{</table>\n};

	print qq{<div><input type="submit" value="$lex{Continue}"></div>\n};
    
	print qq{<table cellpadding="10" cellspacing="0" border="1">\n};    
	print qq{<tr><th>$lex{Select} $lex{Objective}</th></tr>\n};
    
	foreach  my $idnum ( sort {$a <=> $b} keys %objectives ) {
	    my $description = $objectives{$idnum};
	
	    print qq{<tr><td class="la">};
	    if ( not $skip{$idnum} ) { # put in checkbox if not already done.
		print qq{<input type="checkbox" name="$catnum:$idnum" value="1"><i>$idnum</i>};
	    }
	    print qq{. $description</td></tr>\n};
	}


	# Personal Goals for this Goal Group
	foreach my $idx (1..6) {
	    print qq{<tr><td class="la"><b>Your Goal $idx</b>. };
	    print qq{<input type="text" name="$catnum:PER-$idx" style="width:50em;">};
	    print qq{</td></tr>\n};
	}
	
	print qq{</table><input type="submit" value="$lex{Continue}">\n};

    } # end of catnum loop (goal group loop)
	
    print qq{</form>\n};
    
    print qq{</body></html>\n};
    exit;

} # End of selectGoals



#---------------
sub writeRecord {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $studnum = $arr{studnum};
    delete $arr{studnum};
    
    # Do Staff Records first, 
    # Then the Goals, then Mastery

    
    # Do the staff updates first.
    foreach my $key ( %arr ) {
	my ($catnum, $type, $val ) = split(':', $key );

	if ( $type =~ m/resp/  and $arr{$key} ) { # responsibility, and have a value
	    $type =~ s/resp-//; # strip leading; leaving the number
	    my $skey = $catnum. ':staff-'. $type; # create the staff key
	    my $userid = $arr{$skey};

	    # insert a staff record, after getting mainid value.
	    my $sth = $dbh->prepare("select id from evmst_main where studnum = ? and catnum = ?");
	    $sth->execute($studnum, $catnum);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $mainid = $sth->fetchrow;
    
	    my $sth = $dbh->prepare("insert into evmst_staff ( mainid, userid, strategy ) values (?,?,?)");
	    $sth->execute( $mainid, $userid, $arr{$key} );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	    delete $arr{$skey};
	    delete $arr{$key};
	    
	}
    }	

    print qq{<div>Staff Responsibility Stored</div>\n};

    # Remove staff and responsibility values from %arr
    foreach my $key ( keys %arr ) {
	my ($catnum, $val, $other) = split(':', $key);
	if ( $val =~ m/resp|staff/ ) {
	    delete $arr{$key};
	}
    }


    my $sth1 = $dbh->prepare("select description from subject where catnum = ? and idnum = ?");

    # Get passed system goals
    my %goals;
    foreach my $key ( keys %arr ) {
	my ($catnum, $val, $other) = split(':', $key);

#	print qq{CATNUM:$catnum VAL:$val OTHER:$other<br>\n};

	my ($idnum, $desc);
	if ( $val =~ m/^[0-9]+$/ ) { # if we have a digit only...
	    $idnum = $val; # it is an idnum

	    # Get description from subject, since a system goal
	    $sth1->execute( $catnum, $idnum );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    $desc = $sth1->fetchrow;
	    
	} elsif ( $val =~ m/PER/ and $arr{$key} ) { # we have personal goal record
	    $idnum = $val;
	    $desc = $arr{$key};
	} else { next; } # no matches, then back to top of loop.

	# Get Main Id for this catnum/student
	my $sth = $dbh->prepare("select id from evmst_main where studnum = ? and catnum = ?");
	$sth->execute($studnum, $catnum);
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $mainid = $sth->fetchrow;

	# Add the Goal Record
	my $sth = $dbh->prepare("insert into evmst_goal ( mainid, description, idnum ) values (?,?,?)");
	$sth->execute( $mainid, $desc, $idnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	# Get the ID for this goal record.
	my $sth = $dbh->prepare("select id from  evmst_goal where mainid = ? and description = ? and  idnum = ?");
	$sth->execute( $mainid, $desc, $idnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $goalid = $sth->fetchrow;


	foreach my $term (1..10) { # go to 10, just in case, worst case scenario
	    my $mkey;
	    if ( $idnum =~ m/PER/ ) {
		my $temp = $idnum;
		$temp =~ s/ER//; # strip ER characters.
		$mkey = qq{$catnum:$temp:$term};
#		print "KEY for PErsonal Mastery:$mkey<br>\n";
	    } else {
		$mkey = qq{$catnum:M-$idnum:$term};
	    }

		
	    if ( $arr{$mkey} ) { # if we have a value for this mastery for this goal,
		# print "GID:$goalid KEY:$mkey Mastery:$arr{$mkey}, TERM:$term<br>\n";
		my $sth = $dbh->prepare("insert into evmst_mastery ( goalid, mastery, term ) values (?,?,?)");
		$sth->execute( $goalid, $arr{$mkey}, $term );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    }
	}
		    


    } # loop over full %arr loop
	
    print qq{<div>Goals Stored</div>\n};
	
    
    print qq{<p>[ <a href="$iephome">$lex{Main}</a> |\n};
    print qq{<a href="$self">$lex{'Add More'}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;


} # end of writeRecords
