#!/usr/bin/perl
#  Copyright 2001-2017 Leslie Richardson

#  This file is part of Open Admin for Schools.

# March 2017: Due to studnum collisions, added a studnum_local and any
# collisions will lead to assigning a new number starting at 99901.


#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Birthdate' => 'Birthdate',
	   'Student Number' => 'Student Number',
	   'Provincial Number' => 'Provincial Number',
	   'Designation Date' => 'Designation Date',
	   'DDPF Level' => 'DDPF Level',
	   'Designation' => 'Designation',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'M' => 'M',
	   'F' => 'F',
	   'Medical Conditions' => 'Medical Conditions',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'School/Home History' => 'School/Home History',
	   'Save' => 'Save',
	   'Contact' => 'Contact',
	   'Search' => 'Search',
	   'Please Log In' => 'Please Log In',
	   'Team Members' => 'Team Members',
	   'Strengths' => 'Strengths',
	   'Challenges' => 'Challenges',
	   'Assessments' => 'Assessments',
	   'Additional' => 'Additional',

	   'Last,First/Last/Initials/Studnum' => 'Last,First/Last/Initials/Studnum',
	   'Not Found' => 'Not Found',
	   'Exists' => 'Exists',
	   'Record' => 'Record',
	   'Student' => 'Student',
	   'Record Added' => 'Record Added',
	   'Add' => 'Add',
	   'Number' => 'Number',

	   );

my $self = 'spadd.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "ppp.conf";
if ( $@ ) {
    print "$lex{Error} $@<br>\n";
    die " $lex{Error} $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# IEP Database;
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></body></html>\n};
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;


# set DB values for the school's dbase of the user.
my $dsn1 = "DBI:$dbtype:dbname=$schooldbase";
my $dbh1 = DBI->connect($dsn1,$guser,$gpassword);


# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


my $title = "$lex{Add} $lex{Student}";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{</head><body>[ <a href="$iephome">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( $arr{page} == 1 ) {
    delete $arr{page};
    writeRecord();
}

if ( not $studnum ){ # display entry error
    no_student_error();
}

my %sr; # student record

# School Database - Get Student Data
my $sth = $dbh1->prepare("select * from student where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  

my $ref = $sth->fetchrow_hashref;
%sr = %$ref;
my $school = "$dbase{$schooldbase} ($database)";


if ( not $sr{studnum} ){  # no student found!
    no_student_error( "$lex{Number} $lex{'Not Found'}" );
}



print qq{<form action="$self" method="post">\n};
print qq{<input type="hidden" name="page" value="1">\n};
print qq{<input type="hidden" name="studnum" value="$studnum">\n};
print qq{<table cellpadding="3" cellspacing="0" border = "0">\n};

print qq{<tr><td class="bra">$lex{'Last Name'}</td>\n<td>};
print qq{<input type="text" name="lastname" size="30" value="$sr{lastname}"></td></tr>\n};

print qq{<tr><td class="bra">$lex{'First Name'}</td>\n<td>};
print qq{<input type="text" name="firstname" size="30" value="$sr{firstname}"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Birthdate}</td>\n<td>};
print qq{<input type="text" name="birthdate" size="15" value="$sr{birthdate}">};
print qq{ (yyyy-mm-dd)</td></tr>\n};

print qq{<tr><td class="bra">$lex{'Student Number'}</td><td>$studnum</td></tr>\n};

print qq{<tr><td class="bra">$lex{'Provincial Number'}</td>\n<td>};
print qq{<input type="text" name="provnum" size="12" value="$sr{provnum}"></tr>\n};

#print qq{<tr><td class="bra">". $lex{'Designation Date'}. "</td>\n<td>";
#print qq{<input type="text" name="desdate" size="15">\n};
#print qq{ (yyyy-mm-dd)</td></tr>\n};

#print qq{<tr><td class="bra">". $lex{'DDPF Level'}. "</td>\n<td>";
#print qq{<select name="ddpflvl"><option></option><option>Level 1</option>\n};
#print qq{<option>Level 2</option></td></tr>\n};

print qq{<tr><td class="bra">$lex{Designation}</td>\n<td>};
print qq{<select name="designation"><option></option>\n};
foreach my $desig ( @designate ) {
    print qq{<option>$desig</option>\n};
}
print qq{</select></td></tr>\n};

print qq{<tr><td class="bra">$lex{Grade}</td>\n<td>};
print qq{<input type="text" name="grade" size="4" value="$sr{grade}"></td></tr>\n};

print qq{<tr><td class="bra">$lex{School}</td>\n<td>};
print qq{$dbase{$schooldbase} ($schooldbase)\n};
print qq{<input type="hidden" name="school" value="$schooldbase">\n};
print qq{</td></tr>\n};

print qq{<tr><td class="bra">$lex{Gender}</td>\n<td>};
print qq{<select name="sex"><option>$sr{sex}</option>\n};
print qq{<option>$lex{M}</option><option>$lex{F}</option></select></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{'Medical Conditions'}</td>\n<td>};
print qq{<textarea name="medical" rows="6" cols="100">$sr{medical}</textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Medication}</td>\n<td>};
print qq{<textarea name="medication" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Equipment}</td>\n<td>};
print qq{<textarea name="equip" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Adaptations}</td>\n<td>};
print qq{<textarea name="adapt" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{'School/Home History'}</td>\n};
print qq{<td><textarea name="history" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Strengths}</td>\n};
print qq{<td><textarea name="strengths" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Challenges}</td>\n};
print qq{<td><textarea name="challenges" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Assessments}</td>\n};
print qq{<td><textarea name="assessments" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td class="bra" valign="top">$lex{Additional}</td>\n};
print qq{<td><textarea name="additional" rows="6" cols="100"></textarea></td></tr>\n};

print qq{<tr><td colspan="2" class="cn"><input type="submit" };
print qq{value="$lex{Save} $lex{Record}"></td></tr></table>\n};

print qq{</form></body></html>\n};


#-------------------
sub no_student_error {
#-------------------

    my $message = shift;
    print qq{<p>$message</p>\n};

    print qq{<p style="text-align:left;font-weight:bold;">$lex{Student} $lex{Search}<br>\n};
    print qq{<table cellpadding="3" cellspacing="0" border="1"><tr><td>\n};
    print qq{<form action="studsearch.pl" method="post">\n};

    print qq{$lex{'Last,First/Last/Initials/Studnum'}<br>};
    print qq{<input type="text" name="student" size="12"><br>\n};
    print qq{<input type="submit" value="$lex{Search}"></form>\n};


    print qq{<input type="text" name="student" size="25">\n};
    print qq{<input type="submit" value="$lex{Search}">\n};
    print qq{</form></td></tr></table></p>\n};

    print qq{</body></html>\n};

    exit;

}


#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my $studnum = $arr{studnum}; # unquoted version for link to next script.
    
    # Check for existing student, with same student number.
    my $sth = $dbh->prepare("select count(*) from special where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;

    if ( $count ) {  # we have to use a new number and save the existing one into student_local field.
	$arr{'studnum_local'} = $studnum;  # set existing one to new field.

	# Get a Max number for new student number.
	my $sth = $dbh->prepare("select max(studnum) from special");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $newstudnum = $sth->fetchrow;
	$newstudnum++; # get the next number past max.

	$arr{studnum} = $newstudnum;

	print qq{<h3>$lex{Student} $lex{Exists}</h3>\n};
	print qq{<div>Local Student Number:$arr{studnum_local} New IEP Studnum:$arr{studnum}</div>\n};
	
    }
	

    # Join parts together
    my @keys = keys %arr;
    my $keys = join(',', @keys);
	
    foreach my $k ( keys %arr ) {
	if ( $arr{$k} ) {
	    $arr{$k} = $dbh->quote( $arr{$k} );
	} else {
	    $arr{$k} = $sql{default};
	}
    }
    my $values = join(',', ( values %arr ));

    $sth = $dbh->prepare("insert into special ( $keys ) values ( $values )");
    $sth->execute;


    if ( not $DBI::errstr ) {
	print qq{<h3>$lex{'Record Added'}</h3>\n};

    } else {
	print qq{<h3>Error: $DBI::errstr<br>\n};
	print qq{$lex{Contact} $adminname <a href="mailto:$adminemail">$adminemail</a></h3>\n};

    }

    print qq{<p>[ <a href="$iephome">$lex{Main}</a> ]\n};

    print qq{<form action="tmadd.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};
    print qq{<input type="submit" value="$lex{Add} $lex{'Team Members'}">\n};
    print qq{</form>\n};

    print qq{</p></body></html>\n};

    exit;

} # end of writeRecord
