#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Special Needs Students' => 'Special Needs Students',
	   'Description' => 'Description',
	   'Name/ID' => 'Name/ID',
	   'Edit' => 'Edit',
	   'Error' => 'Error',
	   'BDate' => 'BDate',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'Studnum' => 'Studnum',
	   'ProvNum' => 'ProvNum',
	   'Designation' => 'Designation',
	   'Des Date' => 'Des Date',
	   'Medical' => 'Medical',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'History' => 'History',
	   'Please Log In' => 'Please Log In',

	   'Strengths' => 'Strengths',
	   'Challenges' => 'Challenges',
	   'Assessments' => 'Assessments',
	   'Additional' => 'Additional',
	   'Full View' => 'Full View',
	   'DDPF Level' => 'DDPF Level',

	   );

my $self = 'spdeled.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
my %arr = $q->Vars;

my $fullview = $arr{fullview};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


my $sth = $dbh->prepare("select * from special $select order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

# Print Page Header.
print "$doctype\n<html><head><title>$lex{'Special Needs Students'}</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
print "<a name=\"top\"></a>[ <a href=\"$iephome\">$lex{Main}</a> ]\n";

# Full view form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"hidden\" name=\"fullview\" value=\"1\">\n";
print "<input type=\"submit\" value=\"$lex{'Full View'}\"></form>\n";


print "$firstname $lastname ($schooldbase)\n";
print "<center><h1>". $lex{'Special Needs Students'}. "</h1><p>$currdate</p>\n";


print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\" style=\"text-align:left;\">\n";
print "<tr><th>". $lex{'Name/ID'}. "</th><th>". $lex{Description}. "</th></tr>\n";



while ( my $ref = $sth->fetchrow_hashref ) {
    my %arr = %$ref;

    if ( not $fullview ){

	print "<tr><td>";

	print "<form action=\"sped.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\">\n";
	print "</form>\n";

	print "<b>$arr{lastname}</b>, $arr{firstname} ($arr{studnum})\n";
	print "</td><td>$arr{designation}</td></tr>\n";

    } else { # print complete records

        print "<tr><td valign=\"top\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" style=\"text-align:left;\">\n";
	print "<tr><td colspan=\"2\" align=\"center\"><b>$arr{firstname} $arr{lastname}</b></td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{BDate}. "</em></td><td>$arr{birthdate}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Grade}. "</em></td><td>$arr{grade}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{School}. "</em></td><td>$arr{school}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Gender}. "</em></td><td>$arr{sex}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Studnum}. "</em></td><td> $arr{studnum}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{ProvNum}. "</em></td><td> $arr{provnum}</td></tr>\n";
	print "</table>\n";

	print "<form action=\"sped.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\">\n";
	print "</form>\n";

	print "</td>\n";
	print "<td valign=\"top\"><table cellpadding=\"3\" style=\"text-align:left;\">\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Designation};
	print "</em></td><td>$arr{designation}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'DDPF Level'};
	print "</em></td><td>$arr{ddpflvl}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'Des Date'};
	print "</em></td><td>$arr{desdate}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medical};
	print "</em></td><td>$arr{medical}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medication};
	print "</em></td><td>$arr{medication}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Equipment};
	print "</em></td><td>$arr{equip}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Adaptations};
	print "</em></td><td>$arr{adapt}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{History};
	print "</em></td><td>$arr{history}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Strengths};
	print "</em></td><td>$arr{strengths}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Challenges};
	print "</em></td><td>$arr{challenges}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Assessments};
	print "</em></td><td>$arr{assessments}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Additional};
	print "</em></td><td>$arr{additional}</td></tr>\n";

	print "</table></td></tr>\n";

    } # end of If/Else
}

print "</table></center></body></html>\n";
