#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

# This file is part of Open Admin for Schools.

my %lex = ('Team Builder' => 'Team Builder',
	   'Main' => 'Main',
	   'Please select the student team members' => 'Please select the student team members',
	   'Select Student' => 'Select Student',
	   'Add Members to the Student\'s Team' => 'Add Members to the Student\'s Team',
	   'Personnel' => 'Personnel',
	   'Name' => 'Name',
	   'Position' => 'Position',
	   'Userid' => 'Userid',
	   'Select' => 'Select',
	   'Signer' => 'Signer',
	   'Add More Team Members' => 'Add More Team Members',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'Your new team members are now stored' => 'Your new team members are now stored',
	   'Y' => 'Y',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Assessments' => 'Continue to Add Assessments',

	   );

my $self = 'teamadd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></body></html>\n};
    exit;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";

# Print Page Header
print qq{$doctype\n<html><head><title>$lex{'Team Builder'}</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
print qq{[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname\n};
print qq{<h1>$lex{'Team Builder'}</h1>\n};

if ( not $arr{page} ) {
    showStartPage();

} elsif ($arr{page} == 1 ) {
    delete $arr{page};
    selectTeam();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------

    # Start the form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};

    print qq{<input type="submit" value="Continue">\n};

    # Select the Student
    print qq{<table cellpadding="6" cellspacing="0" border="1">\n};

    print qq{<tr><th class="bcn">$lex{'Select Student'}</th></tr>\n};

    # Read in all special students and put in array
    my $sth = $dbh->prepare("select lastname, firstname, studnum from special $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
	print qq{<tr><td class="la"><input type="radio" name="studnum" value="$studnum"><b>$lastname</b>, $firstname</td></tr>\n};
    }
	
    print qq{</table>\n};
    print qq{<input type="submit" value="Continue">\n};
    print qq{</form>\n};
    print qq{</body></html>\n};

    exit;


}

#-------------
sub selectTeam {
#-------------

    # foreach $key (keys %arr) { print qq{K:$key V:$arr{$key}<br>\n}; }
    
    if ( not $arr{studnum} ){
	print qq{<h1>No Student Entered. Please try again.</h1>\n};
	print qq{</body></html>\n};
	exit;
    }

    my $studnum = $arr{studnum};
    delete $arr{studnum};

    # Get Student Name
    my $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    

    # Display Current Team
    print qq{<h3>Current Team for $firstname $lastname</h3>\n};
    print qq{<table cellpadding="6" cellspacing="0" border="1" stle="margin-bottom:1em;">\n};
    print qq{<tr><th>$lex{Name}</th><th>$lex{Position}</th></tr>\n};
    
    # Get Current Team
    my $sth = $dbh->prepare("select * from team where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	print qq{<tr><td><b>$r{lastname}</b>, $r{firstname}</td><td>$r{jobtitle}</td></tr>\n};
    }
    print qq{</table>\n};

    
    # Start Form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="studnum" value="$studnum">\n};
    
    
    print qq{<p><input type="submit" value="$lex{'Add Members to the Student\'s Team'}"></p>\n};

    
    # Now pull in the personnel table.
    my $sth = $dbh->prepare("select userid, lastname, firstname, jobtitle from personnel
     order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    

    # Now print Personnel
    print qq{<h2>$lex{Personnel}</h2>\n};
    print qq{<table cellpadding="4" cellspacing="0" border="1">\n};
    print qq{<tr><th>$lex{Name}</th><th>$lex{Position}</th><th>$lex{Userid}</th>\n};
    print qq{<th>$lex{Select}</th><th>$lex{Signer}</th></tr>\n};

    while ( my ($userid, $lastname, $firstname, $jobtitle) = $sth->fetchrow ) {
	print qq{<tr><td><b>$lastname</b>, $firstname</td><td>$jobtitle</td>\n};
	print qq{<td>$userid</td><td class="cn">\n};
	print qq{<input type="checkbox" name="per:$userid" value="1"></td>\n};
	print qq{<td><input type="checkbox" name="per:$userid:sign" value="1"></td></tr>\n};
    }
    print qq{</table>\n};

    # Connect to the School Database
    my $dsn = "DBI:$dbtype:dbname=$schooldbase";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

#    my $sth = $dbh->prepare("select s.sal, s.lastname, s.firstname, s.userid, sm.field_value 
#     from staff as s, staff_multi as sm where s.userid = sm.userid and sm.field_name = 'position'
#     order by lastname, firstname");

    my $sth = $dbh->prepare("select * from staff order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print qq{<h2>$dbase{$schooldbase}</h2>\n};
    print qq{<table cellpadding="4" cellspacing="0" border="2">\n};
    print qq{<tr><th>$lex{Name}</th><th>$lex{Position}</th><th>$lex{Userid}</th>\n};
    print qq{<th>$lex{Select}</th><th>$lex{Signer}</th></tr>\n};

    my $sth1 = $dbh->prepare("select field_value from staff_multi where userid = ? and field_name = 'position'");
    
    while ( my $ref = $sth->fetchrow_hashref ) {
	# ($sal, $lastname, $firstname, $userid,$position) = $sth->fetchrow ) {
	my %r = %$ref;

	# Get staff job position
	$sth1->execute( $r{userid} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $position = $sth1->fetchrow;
	
	print qq{<tr><td><b>$r{lastname}</b>, $r{sal} $r{firstname}</td><td>$position</td>\n};
	print qq{<td>$r{userid}</td><td class="cn"> };
	print qq{<input type="checkbox" name="$schooldbase:$r{userid}" value="1"></td>\n<td>};
	print qq{<input type="checkbox" name="$schooldbase:$r{userid}:sign" value="1"></td></tr>\n};
	
    }
    print qq{</table>\n};

    print qq{<p></p><input type="submit" value="$lex{'Add Members to the Student\'s Team'}">\n};
    print qq{</form></body></html>\n};

    exit;

} # end of selectTeam

    


#--------------
sub writeRecord {
#--------------

    # foreach $key (keys %arr) { print qq{K:$key V:$arr{$key}<br>\n}; }
    # passed: studnum, db:userid, db:userid:sign

    
    if ( not $arr{studnum} ){
	print qq{<h1>No Student Entered. Please try again.</h1>\n};
	print qq{</body></html>\n};
	exit;
    }

    my $studnum = $arr{studnum};
    delete $arr{studnum};

    my $dsn = "DBI:$dbtype:$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    foreach $key ( keys %arr ) {

	my ($group, $userid, $sign) = split(':',$key );
	if ( $sign ){ next;} # skip over signing records

	my $sth = $dbh->prepare("insert into team (studnum, userid, jobtitle, phone, email, sign, lastname, firstname, schooldbase )
          values ( ?, ?, ?, ?, ?, ?, ?, ?, ? )");

	if ( $group eq 'per' ) {  # A user from personnel table.
	    my $sth1 = $dbh->prepare("select * from personnel where userid = ?");
	    $sth1->execute( $userid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my $ref = $sth1->fetchrow_hashref;
	    my %r = %$ref;

	    my $signer;
	    my $val = $key.":sign";
	    if ( $arr{$val} ){ $signer = $lex{Y}; }

	    $sth->execute( $studnum, $userid , $r{jobtitle}, $r{phone}, $r{email}, $signer, $r{lastname},$r{firstname},'personnel');
	    if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
	    

	} else { # A teacher or TA in school

	    $dsg = "DBI:$dbtype:$group";
	    $dbg = DBI->connect($dsg,$guser,$gpassword);
	    $sth1 = $dbg->prepare("select s.lastname, s.firstname, sm.field_value, s.email 
             from staff as s, staff_multi as sm where s.userid = sm.userid and 
             sm.field_name = 'position' and s.userid = ?");
	    $sth1->execute( $userid );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $lastname, $firstname, $position, $email ) = $sth1->fetchrow;

	    my $signer;
	    my $val = $key.":sign";
	    if ( $arr{$val} ){ $signer = $lex{Y}; }
	    #print qq{K:$key V:$val  S:$signer\n};
	    
	    $sth->execute( $studnum, $userid, $position, $g_phone{$group}, $email, $signer, $lastname, $firstname, $group );
	    if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }

	} 


    } # End of Entry Loop


    if ( not $DBI::errstr ) {
	print qq{<h3>$lex{'Your new team members are now stored'}</h3>\n};
	
    } else {
	print qq{<h3>$lex{'There was an error storing your data'}\n};
	print qq{$lex{Contact} $adminname <a href="mailto:$adminemail">$adminname</a>\n};
	print qq{$lex{'Please record the following error'}: $DBI::errstr\n};
    }

    print qq{<p>[ <a href="$iephome">$lex{Main}</a> |\n};
    print qq{<a href="$self?studnum=$studnum">$lex{'Add More Team Members'}</a> |\n};

    print qq{</p></body></html>\n};

    exit;

} # end of writeRecord
