#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Delete Educator' => 'Delete Educator',
	   'Admin' => 'Admin',
	   'Name' => 'Name',
	   'Error' => 'Error',
	   'Are you sure you want to delete this record?' => 
	     'Are you sure you want to delete this record?',
	   'Yes, delete the record!' => 'Yes, delete the record!',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Record deleted' => 'Record deleted',
	   'View/Edit/Delete Educators' => 'View/Edit/Delete Educators',

	   );

my $self = 'edudel.pl';

use CGI;
use DBI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $self:$@<br>\n";
    die $lex{Error}. " $self:$@\n";
}

my $q = new CGI;
print $q->header;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Page Header.
my $title = $lex{'Delete Educator'};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{</head><body>};
print qq{[ <a href="$adminpage">$lex{Admin}</a> ]\n};


print qq{<h1>$title</h1>\n};

if ( $arr{itemid} ) {
    deleteRecord();
}

my $sth = $dbh->prepare("select * from educator where id = ?");
$sth->execute( $arr{id} );
if ($DBI::errstr){print qq{$DBI::errstr"; die $DBI::errstr; }};
my $ed = $sth->fetchrow_hashref;

print qq{<div style="padding:1em;"><b>$ed->{firstname} $ed->{lastname} ($ed->{userid})</b></div>\n};


print qq{<p><em>$lex{'Are you sure you want to delete this record?'}</em></p>\n};
print qq{<form action="$self" method="post">\n};
print qq{<input type="hidden" name="itemid" value="$ed->{id}">\n};
print qq{<input type="submit" value="$lex{'Yes, delete the record!'}">\n};
print qq{</form></body></html>\n};



#---------------
sub deleteRecord {
#---------------

    foreach my $key ( keys %arr) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my $sth = $dbh->prepare("delete from educator where id = ?");
    $sth->execute( $arr{itemid} );

    if ($DBI::errstr) {
	print qq{$lex{Error}: $DBI::errstr<br>\n};

    } else {
	print qq{<h2>$lex{'Record deleted'}.</h2>\n};
    }

    print qq{<p>[ <a href="$adminpage">$lex{Admin}</a> |\n};
    print qq{<a href="eduview.pl">$lex{'View/Edit/Delete Educators'}</a> ]\n}; 
    print qq{</body></html>\n};

    exit;

};
