#!/usr/bin/perl
#  Copyright 2001-2017 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Personnel Entry' => 'Personnel Entry',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'User Id' => 'User Id',
	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Job Title' => 'Job Title',
	   'Agency' => 'Agency',
	   'Phone' => 'Phone',
	   'E-Mail' => 'E-Mail',
	   'Save Personnel Record' => 'Save Personnel Record',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Record the following error' => 'Record the following error',
	   'Contact' => 'Contact',
	   'Your record is now stored' => 'Your record is now stored',
	   'Missing User Id or Name' => 'Missing User Id or Name',
	   'Userid already exists' => 'Userid already exists',
	   'Please try again' => 'Please try again',
	   'Edit/Delete Personnel Records' => 'Edit/Delete Personnel Records',
	   'Password' => 'Password',
	   
	   );

my $self = 'pradd.pl';

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $studnum = $arr{studnum};

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $title =  $lex{'Personnel Entry'};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="/iep.css" type="text/css"></head><body>\n};
print qq{[ <a href="$adminpage">$lex{Admin}</a> ]\n};
print qq{<h2>$lex{'Personnel Entry'}</h2>\n};

if ( $arr{flag} ) {
    delete $arr{flag};
    addRecord();
}


print qq{<form action="$self" method="post">\n};
print qq{<input type="hidden" name="flag" value="1">\n};
print qq{<table cellpadding="3" cellspacing="0" border="1">\n};

print qq{<tr><td class="bra">$lex{'User Id'}</td>};
print qq{<td><input type="text" name="userid" size="10"></td></tr>\n};

print qq{<tr><td class="bra">$lex{'Password'}</td>\n<td>};
print qq{<input type="text" name="password" size="20"></td></tr>\n};


print qq{<tr><td class="bra">$lex{'Last Name'}</td>\n<td>};
print qq{<input type="text" name="lastname" size="25"></td></tr>\n};

print qq{<tr><td class="bra">$lex{'First Name'}</td>\n<td>};
print qq{<input type="text" name="firstname" size="25"></td></tr>\n};

print qq{<tr><td class="bra">$lex{'Job Title'}</td>\n<td>};
print qq{<input type="text" name="jobtitle" size="20" ></td></tr>\n};

print qq{<tr><td class="bra">$lex{Agency}</td>\n<td>};
print qq{<input type="text" name="agency" size="20"></td></tr>\n};

print qq{<tr><td class="bra">$lex{Phone}</td>\n<td>};
print qq{<input type="text" name="phone" size="20"></td></tr>\n};

print qq{<tr><td class="bra">$lex{'E-Mail'}</td>\n<td>};
print qq{<input type="text" name="email" size="20"></td></tr>\n};


print qq{<tr><td></td><td class="la">\n};
print qq{<input type="submit" value="$lex{'Save Personnel Record'}">\n};
print qq{</td></tr></table>\n};

print qq{</form></body></html>\n};



#------------
sub addRecord {
#------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    # Check for missing values
    if (not $arr{userid} or 
	not $arr{lastname} or 
	not $arr{firstname} ) {
	
	print qq{<h1>$lex{'Missing User Id or Name'}</h1>\n};
	print qq{</body></html>\n};
	exit;
    }

    # Check for existing user ids.
    my $sth = $dbh->prepare("select count(userid) from personnel where userid = ?");
    $sth->execute( $arr{userid} );
    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ( $count > 0 ) {
	print qq{<h1>$lex{'Userid already exists'}.\n};
	print qq{$lex{'Please try again'}</h1>\n};
	print qq{</body></html>\n};
	exit;
    }


    foreach my $key (keys %arr) { 
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
    }

    $sth = $dbh->prepare("insert into personnel values (
     $sql{default}, $arr{userid}, $arr{lastname}, $arr{firstname},
     $arr{jobtitle}, $arr{agency}, $arr{phone}, $arr{email}, $arr{password} )");
    $sth->execute;

    if (not $DBI::errstr ) {
	print qq{<h3>$lex{'Your record is now stored'}.</h3>\n};
    } else {
	print qq{<h3>$lex{'There was an error storing your data'} };
	print qq{$lex{Contact} $adminname <a href="mailto:$adminemail">$adminemail</a>\n};
	print qq{ $lex{Error} $DBI::errstr</h3></p>\n};
    }

    print qq{<p>[ <a href="$adminpage">$lex{Admin}</a> |\n};
    print qq{<a href="prdeled.pl">$lex{'Edit/Delete Personnel Records'}</a> ]\n}; 
    print qq{</p></body></html>\n};

    exit;

}
