#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Used to add an objective to a subject category.
my %lex = ('Admin' => 'Admin',
	   'Add Objectives' => 'Add Objectives',
	   'Select Category' => 'Select Category',
	   'New Category' => 'New Category',
	   'OR' => 'OR',
	   'Use ONE or the OTHER of the two above, but Not Both!' =>
	     'Use ONE or the OTHER of the two above, but Not Both!',
	   'New Category Number' => 'New Category Number',
	   'if new category' => 'if new category',
	   'Grade' => 'Grade',
	   'if applicable' => 'if applicable',
	   'Object' => 'Object',
	   'Continue' => 'Continue',
	   'Confirm Objectives' => 'Confirm Objectives',
	   'Category' => 'Category',
	   'Only 1 Category can be entered' => 'Only 1 Category can be entered',
	   'Either existing or new one' => 'Either existing or new one',
	   'Problem with missing value for new category' => 
	     'Problem with missing value for new category',
	   'Add More Objectives' => 'Add More Objectives',
	   'Your record is now stored' => 'Your record is now stored',
	   'Record the following error' => 'Record the following error',
	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',

	   );

my $self = 'subadd.pl';

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}
eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Read in all subject categories and put in array
$sth = $dbh->prepare("select distinct category,catnum from subject 
  order by category");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my ($category,$catnum) = $sth->fetchrow ){
    push @catarray, "$category ($catnum)";
}

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Objectives'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Add Objectives'}. "</h1>\n";

if ( $arr{page} == 1 ) {
    delete $arr{page};
    confirmObjectives();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecords();
}


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<p><input type=\"submit\" value=\"". $lex{Continue}. "\"></p>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><td align=\"right\">". $lex{'Select Category'}. "</td>\n";
print "<td><select name=\"subject\"><option></option>\n";

foreach my $subject ( @catarray ){
    print "<option>$subject</option>\n";
}
print "</select></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{OR}. "</b> ". $lex{'New Category'}. "</td>\n";
print "<td><input type=\"text\" name=\"newcategory\" size=\"30\"></td></tr>\n";
print "<tr><td colspan=\"2\" align=\"center\"><b>";
print $lex{'Use ONE or the OTHER of the two above, but Not Both!'}. "</b></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'New Category Number'}. "</td>\n";
print "<td><input type=\"text\" name=\"newcatnumber\" size=\"8\"> (". $lex{'if new category'};
print ")</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Grade}. "</td>\n<td>";
print "<input type=\"text\" name=\"grade\" size=\"6\"> (". $lex{'if applicable'}. ")</td></tr>\n";

for (1..10){
    $objname = "obj".$_;
    print "<tr><td align=\"right\"><i>". $lex{Object}. " $_</i></td><td> \n";
    print "<input type=\"text\" name=\"$objname\" size=\"65\"></td></tr>\n";
}

print "</table><p></p><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
print "</form></body></html>\n";



#--------------------
sub confirmObjectives {
#--------------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";    
    print "<p><input type=\"submit\" value=\"". $lex{'Confirm Objectives'}. "\"></p>\n";

    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><td align=\"right\">". $lex{Category}. "</td>\n<td>$arr{subject}";
    print "<input type=\"hidden\" name=\"subject\" value=\"$arr{subject}\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{OR}. "</b> ". $lex{'New Category'};
    print "</td>\n<td>$arr{newcategory}\n";
    print "<input type=\"hidden\" name=\"newcategory\" value=\"$arr{newcategory}\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'New Category Number'}. "</td>\n<td>";
    print "$arr{newcatnumber}";
    print "<input type=\"hidden\" name=\"newcatnumber\" value=\"$arr{newcatnumber}\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Grade}. "</td><td>$arr{grade}";
    print "<input type=\"hidden\" name=\"grade\" value=\"$arr{grade}\"></td></tr>\n";


    for (1..10){
	$objname = "obj".$_;
	print "<tr><td align=\"right\"><i>". $lex{Object}. " $_</i></td>\n";
	print "<td>$arr{$objname}";
	print "<input type=\"hidden\" name=\"$objname\" value=\"$arr{$objname}\"></td></tr>\n";
    }

    print "</table><p></p><input type=\"submit\" value=\"". $lex{'Confirm Objectives'};
    print "\"></form></body></html>\n";

    exit;

} # end of Confirm Objectives



#--------------
sub writeRecords {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # split the subject apart.
    my ($category, $catnum) = split /\(/, $arr{subject};
    chop $catnum;  # remove trailing )

    # Error Checking
    if ( $arr{newcategory} and $category ){ # Both Entered.
	print "<h1>";
	print $lex{'Only 1 Category can be entered'}. q{. };
	print $lex{'Either existing or new one'}. ".</h1>\n";
	print "</body></html>\n";
	die;
    }

    if ( $arr{newcategory} and not $arr{newcatnumber} or
	$arr{newcatnumber} and not $arr{newcategory} ) {
	print "<h1>". $lex{'Problem with missing value for new category'}. ".</h1>\n";
	print "</body></html>\n";
	die;
    }


    # Set New values.
    if ( $arr{newcategory} ) {
	$category = $arr{newcategory};
	$catnum = $arr{newcatnumber};
    }

    # Check for existing subject records with this category/catnum
    my $sth = $dbh->prepare("select count(*) from subject where catnum = ?");
    $sth->execute( $catnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    my $maxid;
    if ( $count > 0 ) { # We have existing records for this subject; check for recs.
	my $sth = $dbh->prepare("select max(idnum) from subject where catnum = ?");
	$sth->execute( $catnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	$maxid = $sth->fetchrow;
    }
    $startid = $maxid + 1;

    $sth = $dbh->prepare("insert into subject (catnum, category, idnum, grade, description )
      values ( ?, ?, ?, ?, ? )");

    for my $i (1..10) {
	$objname = "obj".$i;
	if ( $arr{$objname} ) {
	    $sth->execute( $catnum, $category, $startid, $arr{grade}, $arr{$objname} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $startid++;
	} # end of if objective exists.
    }

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Your record is now stored'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". ";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. " $DBI::errstr</h3></p>\n";
    }

    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add More Objectives'}. "</a> ] \n";
    print "</p></center></body></html>\n";

    exit;

}
