#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Power Delete Complete Student Record

my $self = 'totalpwrdel.pl';
my %lex = ('Power Delete Student Records' => 'Power Delete Student Records',
	   'Admin' => 'Admin',
	   'Error' => 'Error',
	   'School' => 'School',
	   'Select' => 'Select',
	   'Chk' => 'Chk',
	   'Student' => 'Student',
	   'Yes, select these schools' => 'Yes, select these schools',
	   'Delete Complete Records of Selected Students' =>
	     'Delete Complete Records of Selected Students',
	   'All records of' => 'All records of',
	   'deleted' => 'deleted',
	   'Record Deletion Failed' => 'Record Deletion Failed',

	   );

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $checked = $arr{checked};

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Page Header
my $title = $lex{'Power Delete Student Records'};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{</head><body>[ <a href="$adminpage">$lex{Admin}</a> ]\n};
print qq{<h1>$title</h1>\n};

if ( not $arr{page} ) {
    showStartPage();
    
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudent();
    
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    deleteStudent();
}

#----------------
sub showStartPage {
#----------------

    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};
    
    print qq{<table border="1" cellspacing="0" cellpadding="3">\n};
    print qq{<tr><th>$lex{School}</th><th>$lex{Select}</th></tr>\n};

    foreach $key ( sort keys %dbase ) {
	print qq{<tr><td>$dbase{$key} ($key)</td>};
	print qq{<td><input type="checkbox" name="$key" value="1" $checked>};
	print qq{</td></tr>\n};
    }

    print qq{<tr><td colspan="2" class="cn">\n};
    print qq{<input type="submit" value="$lex{'Yes, select these schools'}">\n};
    print qq{$lex{Chk} <input type="checkbox" value="checked" name="checked"></td></tr>\n};
    print qq{</form></table></body></html>\n};

}



#-----------------
sub selectStudent {
#-----------------

    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="submit" value="Delete Complete Records">\n};

    foreach my $key (keys %arr){ # Loop through each database.
	
	if ( $key eq 'checked' ){ next; } # skip checked key
	print qq{<h2>$dbase{$key}</h2>\n};
	print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	print qq{<tr><th>$lex{Student}</th><th>$lex{Select}</th></tr>\n};
	
	my $sth = $dbh->prepare("select lastname,firstname, studnum from special
          where school = ? order by lastname, firstname");
	$sth->execute( $key );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	
	while ( my ($lastname,$firstname,$studnum) = $sth->fetchrow){
	    print qq{<tr><td><b>$lastname</b>, $firstname ($studnum)</td>\n};
	    print qq{<td><input type="checkbox" name="$studnum" value="1" $checked>\n};
	    print qq{</td></tr>\n};
	}    
	print qq{</table>\n};
    
    }

    print qq{<div style="padding:0.3em;"><input type="submit" value="};
    print qq{$lex{'Delete Complete Records of Selected Students'}\n};
    print qq{"></div>\n</form></body></html>\n};

    exit;

} # end of selectStudents



#----------------
sub deleteStudent {
#----------------

    #foreach my $key (keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    # Tables to delete records from
    my $sth = $dbh->prepare("select lastname,firstname from special where studnum = ?");

    my $sth1 = $dbh->prepare("delete from eval where studnum = ?");

    my $sth3 = $dbh->prepare("delete from special where studnum = ?");
    my $sth4 = $dbh->prepare("delete from team where studnum = ?");
    my $sth5 = $dbh->prepare("delete from assess where studnum = ?");
    my $sth7 = $dbh->prepare("delete from impact_stud where studnum = ?");

    # Need to 'get' the mainid
    my $sth8 = $dbh->prepare("select id from evmst_main where studnum = ?");
    my $sth9 = $dbh->prepare("select id from evmst_goal where mainid = ?");
    
    my $sth10 = $dbh->prepare("delete from evmst_mastery where goalid = ?");
    my $sth11 = $dbh->prepare("delete from evmst_goal where id = ?");
    my $sth12 = $dbh->prepare("delete from evmst_staff where mainid = ?");
    my $sth13 = $dbh->prepare("delete from evmst_main where id = ?");
    my $sth14 = $dbh->prepare("delete from evalprogress where goalid = ?");
    

    foreach my $studnum ( keys %arr ) {

	# Get Student Name
	$sth->execute( $studnum );
	my ( $lastname,$firstname ) = $sth->fetchrow;

	# Get Main Ids for goals
	$sth8->execute($studnum);
	if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }
	while ( my $mainid = $sth8->fetchrow ) {

	    # Loop Over Goals.
	    $sth9->execute($mainid);
	    if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }
	    while ( my $goalid = $sth9->fetchrow ) {

		# Delete any mastery values 
		$sth10->execute($goalid);
		if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }

		# Delete any evalprogress values
		$sth14->execute($goalid);
		if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }
		
		# Delete the goal
		$sth11->execute($goalid);
		if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }

	    }

	    # Delete Staff Responsibility
	    $sth12->execute($mainid);
	    if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }

	    # Delete the Main evmst record itself.
	    $sth13->execute($mainid);
	    if ( $DBI::errstr ) { print qq{Error:$DBI::errstr;}; die qq{Error:$DBI::errstr;}; }

	}
	    
	
	# Delete his/her records
	$sth1->execute($studnum);

	$sth3->execute($studnum);
	$sth4->execute($studnum);
	$sth5->execute($studnum);

	$sth7->execute($studnum);


	if ($DBI::errstr) {
	    print qq{<p style="color:red;">$lex{'Record Deletion Failed'}.};
	    print qq{$lex{Contact} $adminname<br>\n};
	    print qq{$lex{Error} $DBI::errstr</p>\n};
	}

	print qq{<p>$lex{'All records of'} $firstname $lastname $lex{deleted}.</p>\n};
    
    } # end of student loop

    print qq{<p>[ <a href="$adminpage">$lex{Admin}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

}
