#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Write system variables from a configuration file (.conf) into the
# new conf_system table

# Note: doesn't correctly create hash, array definitions. However,
# just edit them as needed using confadminedit.pl.


my $configpath = '/opt/openadmin/SITE/etc';
my $filename = 'usermanage.conf'; # change to suit
my $shortname = 'usermanage';


use DBI;


eval require "$configpath/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


package oa;

use DBI;
my $dsn = "DBI:mysql:dbname=demo5";
my $dbh = DBI->connect($dsn,'root','PASSWORD');


eval require "../../etc/$filename";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

use Data::Dumper;
$Data::Dumper::Purity = 1;
$Data::Dumper::Indent = 0;

foreach my $key ( sort keys %oa:: ) {

    my $datatype;
    my ( $name_ref, $value_ref );

    if ( $$key ) {
	$name_ref = [ $key ];
	$value_ref = [ $$key ];
	$datatype = 'scalar';
    } elsif ( @$key  ) {
	$name_ref = [ $key  ];
	$value_ref = [ \@$key ];
	$datatype = 'array';
    } elsif  ( %$key ) { 
	$name_ref = [ $key  ];
	$value_ref = [ \%$key ];
       	$datatype = 'hash';
    }

    if ( $value_ref ) {
	my $d = Data::Dumper->new( $value_ref, $name_ref );
	my $dumpedvalues = $d->Dump;

	my $sth = $dbh->prepare("insert into conf_system 
         ( filename, dataname, datatype, version, datavalue ) values
         ( '$shortname', '$key', '$datatype', '5.25', ? )" );

	# print "Name:$shortname  K:$key Type:$datatype\n";

	$sth->execute( $dumpedvalues );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	print $dumpedvalues, "\n";
    }

}

print "Done\n";
