#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

%lex = ( 'Add Student Passwords' => 'Add Student Passwords',
	 'Main' => 'Main',
	 'Error' => 'Error',
	 'Upload Homelogic file' => 'Upload Homelogic file',
	 'Cannot open file' => 'Cannot open file',
	 'Students with Missing Passwords' => 'Students with Missing Passwords',

	 );

use DBI;
use CGI;
use Text::CSV_XS;

my $self = 'addhomelogicpassword.pl';

my $maxbufcount = 500; # 500k max; change as required
my $maxrecorddisplay = 5;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;



my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $csv = Text::CSV_XS->new( {binary => 1} );

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Student Passwords'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]<center>\n";
print "<h1>". $lex{'Add Student Passwords'}. "</h1></center>\n";


if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    updatePasswords();
} 


#------------------
sub updatePasswords {
#------------------

    my $file = $q->param("filename");
    my $name; my $ext; 
    my $filename = $file;  # fileName is output filename, file is input.

    if ( $file ) {

	$filename =~ s!^.*(\\|\/)!!; 
	$filename = lc($filename);
	@name = split /\./, $filename; # split on dots.
        $ext = $name[$#name];  # last element is the extension.
	unless ( $ext eq 'csv' ){
	    print "<b>The file must be a .csv file!</b>";
	    print "</body></html>\n";
	    die;
	}

	pop(@name); # pull off extension.
	foreach $n (@name){ $name .= "$n.";} # assemble name 
	chop; # remove trailing dot

	open ( OUTFILE, ">$filename") || 
	    die "Cannot open file: $filename"; 
	my $bufcount = 0;
        while ( my $bytesread = read( $file, my $buffer, 1024) ) { 
	    print OUTFILE $buffer;
	    $bufcount++;
	    if ( $bufcount > $maxbufcount ) {
		print "<h1>Maximum File Upload size exceeded! ";
		print " ($maxbufcount K)</h1>\n";
		print "</body></html>\n";
		die 'Maximum File Upload size exceeded!';
	    }
	}

	close OUTFILE;
	
    } else {
	print $lex{'Cannot open file'};
	print "</body></html>\n";
	exit;
    }
    # We should now have the file in place.

    # Open csv file for reading
    unless ( open ( FH,"<$filename" ) ) {
	print "Cannot open file: $!\n";
	die $lex{'Cannot open file'}. ": $!\n";
    }

    my $sth = $dbh->prepare("select studnum, password from student 
     where lastname = ? and firstname = ?");

    my $sth2 = $dbh->prepare("select lastname, firstname from student 
     where studnum = ?");

    my $sth1 = $dbh->prepare("update student set password = ? where studnum = ?");


    while ( my $line = <FH> ) {

	#print "LINE: $line<br>\n";
	if ( $csv->parse($line) ) {
	    my ( $fullname, $studnum, $password, $school ) = $csv->fields;
	    if ( $studnum =~ m/[^0-9]/ ) {
		print "Error for $fullname ($studnum) - \n";
		my ($dud, $number ) = split /\(/, $fullname;
	        chop $number;
		$studnum = $number;
		print "Changed to: $studnum<br>\n";

	    }

	    my ($lastname, $rest ) = split /,/, $fullname;
	    my ($firstname, $dud ) = split /\(/, $rest;
	    # strip leading and trailing spaces.
	    $firstname =~ s/^\s+//;
	    $firstname =~ s/\s+$//;

	    #print "Name: $firstname $lastname ($studnum)<br>\n";

	    # Check Name against studnum
	    $sth->execute( $lastname, $firstname );
	    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $teststudnum, $testpassword ) = $sth->fetchrow;
	    #print "<span style=\"color:red;\">Test: $teststudnum - $testpassword</span><br>\n";

	    # Check Studnum against Name
	    #$sth2->execute( $studnum );
	    #if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    #my ( $testlastname, $testfirstname ) = $sth2->fetchrow;
	    #print "STUDNUM:$studnum - |$firstname|$lastname|<br>\n";


	    if ( $teststudnum == $studnum ) { # we have a match
		# print "Studnum Match ";
		# update password, if not the same
		if ( $password ne $testpassword and $password ) { # password exists
		    print "<b>Update: $firstname $lastname ($studnum) $password </b><br>\n";
		    $sth1->execute( $password, $studnum );
		    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		}
	    }


	} else { # Failure to parse
	    print 'Error Reading Record'. ":<br>$line<br>\n";
	    die;
	}
    }

    close FH;
    unlink $filename; # remove uploaded file.

    # Check for students without password
    my $sth = $dbh->prepare("select lastname, firstname, ldap_uid from student 
     where password is NULL or password = '' order by lastname, firstname");
    $sth->execute;
    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $first = 1;
    print "<h1>". $lex{'Students with Missing Passwords'}. "</h1>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    
    while ( my ( $lastname, $firstname, $uid ) = $sth->fetchrow ) {
	print "<tr><td>$firstname $lastname ($uid)</td></tr>\n";
	$first = 0;
    }
    if ( $first ) {
	print "<tr><td>All Students have Passwords</td></tr>\n";
    }
     
    print "</table></ul></center></body></html>\n";

    exit;
}



#----------------
sub showStartPage {
#----------------

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<form action=\"$self\" method=\"post\"  enctype=\"multipart/form-data\">\n";
    print "<tr><td><input type=\"file\" name=\"filename\"></td></tr>\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<tr><td>";
    print "<input type=\"submit\" value=\"". $lex{'Upload Homelogic file'}. "\">\n";
    print "</td></tr></form></table></center></body></html>\n";

    exit;

}
