#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Evaluation Records' => 'Evaluation Records',
	    'Report Card' => 'Report Card',
	    'Main' => 'Main',
	    'Update Record' => 'Update Record',
	    'Mark' => 'Mark',
	    'Subject-Section' => 'Subject-Section',
	    'Student' => 'Student',
	    'Comment' => 'Comment',
	    'Error' => 'Error',
	    'Objective' => 'Objective',
	    'Term' => 'Term',
	    'Evaluation' => 'Evaluation',
	    'Record Updated' => 'Record Updated',
	    'Contact' => 'Contact',
	    'Edit' => 'Edit',
	    'Course' => 'Course',

	   );

my $self = 'evaled.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    print $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = qq{$lex{Edit} $lex{'Evaluation Records'}};
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print qq{[ <a href=\"$homepage\">$lex{Main}</a> | \n};
print qq{<a href=\"$reppage\">$lex{'Report Card'}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


# Get evaluation record; id is passed.
my $sth = $dbh->prepare("select * from eval where id = ?"); 
$sth->execute( $arr{id} );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my $eref = $sth->fetchrow_hashref;
my %r = %$eref;
my $studnum = $r{studnum};
my $subjsec = $r{subjcode};


# Load the subject record (with objectives)
$sth = $dbh->prepare("select * from subject where subjsec = ?"); 
$sth->execute( $subjsec );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
my $ref = $sth->fetchrow_hashref;
my %s = %$ref;


# Student Name
$sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?"); 
$sth->execute( $studnum );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
my ( $lastname, $firstname ) = $sth->fetchrow;


print qq{<form action="$self" method="post">
<input type="hidden" name="id" value="$arr{id}">
<input type="hidden" name="writeflag" value="1">\n};

print qq{<table>\n};

print qq{<tr><td class="bra">$lex{Course} ($lex{'Subject-Section'})</td>};
print qq{<td><i>$s{description}</i> ($subjsec)</td></tr>\n};

print qq{<tr><td class="bra">$lex{Student}</td>};
print qq{<td>$firstname $lastname ($studnum)</td></tr>\n};

print qq{<tr><td class="bra">$lex{Term}</td><td>\n};
#print qq{<input type="text" name="term" size="4" value="$r{term}" maxlength="4">};
print qq{$r{term}};
print qq{</td></tr>\n};

print qq{<tr><td class="bra">$lex{Comment}</td>\n};
print qq{<td class="la"><textarea name="comment" rows="4" cols="60">$r{comment}</textarea></td></tr>\n};


my $ansnum;
for my $i ( 1..20 ) {

    my $ansname = qq{a$i};
    my $qname = qq{q$i};

    if ( $s{$qname} or $i == 1) { # If we have an objective (or at first objective)
	if ( not $s{$qname} ){ $s{$qname} = $lex{Mark}; }
	print qq{<tr><td class="bra">$s{$qname}</td>\n};
	print qq{<td><input type="text" name="$ansname" size="12" maxlength = "12" value="$r{$ansname}">};
	print qq{</td></tr>\n};
    }
}

print qq{</table><p><input type="submit" value="$lex{'Update Record'}">\n};
print qq{</form></body></html>\n};



#---------------
sub updateRecord {
#---------------

    my $id = $arr{id};
    delete $arr{id};

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    # Get subjsec and description for forms below
    my $sth = $dbh->prepare("select subjcode from eval where id = ?");
    $sth->execute( $id );
    my $subjsec = $sth->fetchrow;

    $sth = $dbh->prepare("select description from subject where subjsec = ?");
    $sth->execute( $subjsec );
    my $description = $sth->fetchrow;


    foreach my $key ( sort keys %arr ) { 
	my $sth = $dbh->prepare("update eval set $key = ? where id = $id");
	$sth->execute( $arr{$key} );
    }

    if ( not $DBI::errstr ) { 
	print qq{<h3>$lex{'Record Updated'}</h3>\n};

    } else { 
	print qq{<h3>$lex{Error}: $DBI::errstr<br>\n};
	print qq{$lex{Contact} $adminname <a href=\"mailto:$adminemail\">$adminemail</a> ]</h3>\n};
    }

    print qq{<p>[ <a href="$reppage">$lex{'Report Card'}</a> | \n};
    print qq{<form action="evaldeled.pl" method="post" style="display:inline;">\n};
    print qq{<input type="submit" value="$lex{Edit} $lex{'Evaluation Records'}">\n};
    print qq{</form><p></p>\n};


    print qq{<form action="evaldeled.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="subjsec" value="$subjsec">\n};
    print qq{<input type="submit" value="$lex{Edit} $description"></form>\n};
    print qq{</body></html>\n};

    exit;

}
