#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson
#  This file is part of Open Administration for Schools

use DBI;
use CGI;
use XML::Writer;
use XML::Writer::String;
use Data::UUID;
use HTTP::Request::Common qw(POST); 
use HTTP::Headers; 
use LWP::UserAgent; 
use XML::LibXML;


my $self = 'missingenrollment.pl';


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "slxmllibNew.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = CGI->new;
my %arr = $q->Vars;
print $q->header( -charset, $charset ); 

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
$tim[4]++;
for (0..4){if (length($tim[$_]) == 1){ $tim[$_] = '0'.$tim[$_];}}
my $currdate = "$year-$tim[4]-$tim[3]";
my $currtime = "$tim[2]:$tim[1]:$tim[0]";

my $title = "Students Not Renrolled from Sask Ed";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">$chartype\n";
print "</head><body>[ <a href=\"$reppage\">Report Card</a> ]\n";
#print "<a href=\"$exppage\">Export</a> ]\n";
print "<h1>$title</h1>\n";


getMissing();



#-------------
sub getMissing {
#-------------

    # Create a new user agent
    my $ua = LWP::UserAgent->new();
    $ua->agent("OpenAdmin");

    $count=1;
    qrySchoolCourseHistory($count, $arr{sdate}, $arr{edate}, $arr{startgrade}, $arr{endgrade} ); # Generate $output string

    # DEBUG Data Errors
    $debug = 1;
    if ($debug){
	#print "<div style=\"color: blue;\">\n";
	#print "<h1>DEBUG - Request sent to Sask Ed</h1>\n";
	my $temp = $output->value;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	 print "\n$temp\n\n";
	print "<pre>",$temp,"</pre></div><p></p>\n";
    }

    # Create the https post request 
    my $req = POST $url, [ XML=>$output->value ];

    $req->content_type('application/xml;charset="utf-8"');
    $req->authorization_basic($sds_userid, $sds_password); 


    # Issue the request and receive a response
    my $res = $ua->request($req);

    # Check the status of the response
    if (not $res->is_success) {
	my $err = $res->status_line;
	print "<h1>Transfer Error: $err</h1>";
	exit;
    }

=head
    # For Debugging Data Errors
    if ($debug){
	print "<h1>DEBUG - Sask Ed XML Response</h1>\n";
	print "<div style=\"color:green;\">\n";
	my $temp = $res->content;
#	    $temp =~ s/</&lt;/g;
#	    $temp =~ s/>/&gt;/g;
#	    print "<br>",$temp,"</div>\n";
	print "\n$temp\n";
    }
=cut

    # Parse the response.
    my $parser = XML::LibXML->new();
    
    eval {$doc = $parser->parse_string($res->content)};
    if ($@){
	print "Error: $@<br>\n";
	print "<pre>Sask Ed Error:\n",$res->content,"</pre><br>\n";
	print "</body></html>\n"; die;
    }

    $doc->setEncoding('UTF-8');
    $root = $doc->getDocumentElement;
    $root->setNamespace($xmlns,'s',1);

#=head
    my $check = $root->serialize(1); # 1 is format code.
    $check =~ s/</&lt;/g;
    $check =~ s/>/&gt;/g;
    print "<h3>Response</h3>\n";
    print "<pre>$check</pre>\n\n";
#=cut
    exit;

    # Setup to save to table.
    my $sth = $dbh->prepare("insert into sasked_completedcourses (provnum, birthdate, schoolid, schoolname, 
        courseid, coursetitle, coursetype, schoolyear, courseenddate, finalmark, creditsearned) 
        values (?,?,?,?,?,?,?,?,?,?,?)");


    my $status = $root->findvalue('//s:SL_Status/s:SL_StatusCode');
    if ($status ne 'Successful' ) {
	my $statusmsg = $root->findvalue('//s:SL_Status/s:SL_StatusMsg');
	my $errormsg = $root->findvalue('//s:SL_Error/s:SL_ErrorMsg');
	# Print out error and exit
	print "<h1 style=\"color:red;\">Error: $statusmsg</h1>\n";
	print "<h1 style=\"color:red;\">Error: $errormsg</h1>\n";
	    
	print "</body></html>\n";
	exit;
    }

    # Delete Existing records.
    my $sth1 = $dbh->prepare("delete from sasked_completedcourses");
    $sth1->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    # Parse the StudentCompletedCourses nodes (top level)
    my @sccnodes = $root->findnodes('//s:StudentCompletedCourses');
    foreach my $sccnode ( @sccnodes ) {
	my $provnum = $sccnode->findvalue('s:StudentIdentification/s:DeptAssignedPersonId');
	my $birthdate = $sccnode->findvalue('s:StudentIdentification/s:BirthDate');

	my $sth1 = $dbh->prepare("select lastname, firstname, grade from studentall where provnum = ?");
	$sth1->execute( $provnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname, $grade ) = $sth1->fetchrow;

	my $name;
	if ( $lastname ) {
	    $name = "<b>$lastname</b>, $firstname";
	} else {
	    $name = qq{<span style="color:red;font-weight:bold;">Not Found</span>};
	}

	print "<div>$name ($provnum)</div>\n";

	# Completed School Courses (Each School 
	my @ccnodes = $sccnode->findnodes('s:CompletedSchoolCourses');


	foreach my $ccnode ( @ccnodes ) {
	    my $schoolid = $ccnode->findvalue('s:SchoolId');
	    my $schoolname = $ccnode->findvalue('s:SchoolName');

	    # Parse the courses
	    my @cnodes = $ccnode->findnodes('s:CompletedCourse');

	    foreach my $node ( @cnodes ) {
#		my $coursetype = $node->findvalue('s:CompletedCourse[@Type]');
		my $courseid = $node->findvalue('s:DeptAssignedCourseId');
		my $coursetitle = $node->findvalue('s:CourseTitle');
		my $schoolyear = $node->findvalue('s:SchoolYear');
		my $courseenddate = $node->findvalue('s:CourseEndDate');
		my $finalmark = $node->findvalue('s:FinalMark');
		my $creditsearned = $node->findvalue('s:CreditsEarned');

		$sth->execute( $provnum, $birthdate, $schoolid, $schoolname, $courseid, $coursetitle, $coursetype, 
			       $schoolyear, $courseenddate, $finalmark, $creditsearned);
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


	    } # end of this school course loop.
	} # end of completed school courses loop


	# Completed Other Courses
	my @others = $sccnode->findnodes('s:OtherCompletedCourses');
	my $othernode = $others[0]; #only 1 max for each student.

	# Parse the courses
	my @cnodes = $othernode->findnodes('s:CompletedCourse');
	foreach my $node ( @cnodes ) {
#		my $coursetype = $node->findvalue('s:CompletedCourse[@Type]');
		my $courseid = $node->findvalue('s:DeptAssignedCourseId');
		my $coursetitle = $node->findvalue('s:CourseTitle');
		my $schoolyear = $node->findvalue('s:SchoolYear');
		my $courseenddate = $node->findvalue('s:CourseEndDate');
		my $finalmark = $node->findvalue('s:FinalMark');
		my $creditsearned = $node->findvalue('s:CreditsEarned');


		$sth->execute( $provnum, $birthdate, $schoolid, $schoolname, $courseid, $coursetitle, $coursetype, 
			       $schoolyear, $courseenddate, $finalmark, $creditsearned);
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	} # end of other course loop


    } # end of student completed courses loop.

    print "<h3>Update of Local Completed Course Records from Sask Ed Complete</h3>\n";
    print "</body></html>\n";

    exit;

} # end of getCourseHistory



#--------------------------
sub qrySchoolCourseHistory { 
#--------------------------

    my ($idcount, $startdate, $enddate, $startgrade, $endgrade ) = @_;

    # Create Writer Instance
    $output = new XML::Writer::String;
    my $datamode = 1;
    if ($debug){ $datamode = 1;} # pretty print xml output
    $wr = new XML::Writer(OUTPUT => $output, 
			  DATA_MODE => $datamode, 
			  DATA_INDENT => '2');

    # Set XML Header and write Root Element
    $wr->xmlDecl("UTF-8");
    $wr->startTag('SL_Message','xmlns' =>$xmlns, 
		  'xmlns:xsi' =>$xmlnsxsi, 
		  'xsi:schemaLocation' => $xsischemaLocation);

    $wr->startTag('SL_Request');
    &mkSL_Header($currdate, $currtime, $schoolnumber,$idcount);

    $wr->startTag('SL_Query');


    $wr->startTag('QueryBySchool',
		  'RefId' => "$schoolnumber",
		  'ObjectName' => 'StudentNotReEnrolled',
		  'ScopeCode' => 'All'
		  );

    $wr->dataElement('SchoolId', $schoolnumber);

#    $wr->dataElement('FromDate', '20110801');
#    $wr->dataElement('ToDate', '20120731');

#    $wr->dataElement('FromDate', $startdate);
#    $wr->dataElement('ToDate', $enddate);

#    $wr->emptyTag('FromGrade', 'Code' => '12');
#    $wr->emptyTag('ToGrade', 'Code' => '12');

    $wr->endTag('QueryBySchool');



    $wr->endTag('SL_Query');
    $wr->endTag('SL_Request');
    $wr->endTag('SL_Message');
    $wr->end();
    
} # End of qrySchoolCourseHistory 
