#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Outline: Delete students and all IEP data for each one.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Special Needs Students' => 'Special Needs Students',
	   'Birthdate' => 'Birthdate',
	   'Name' => 'Name',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'BDate' => 'BDate',
	   'Grade' => 'Grade',
	   'Please Log In' => 'Please Log In',
	   'studnum' => 'studnum',
	   'Deleted' => 'Deleted',
	   

	   );

my $self = 'iepdelete.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};
my $fullview = $arr{fullview};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;


if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></body></html>\n";
    exit;

}


my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

# Homerooms and Access for this teacher.
my (%homerooms, %access );

# Get homeroom and check access credentials.
my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'homeroom' and userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while ( my $homeroom = $sth->fetchrow ) {
    $homerooms{$homeroom} = 1;
}

# Get Access credentials
my $sth = $dbh->prepare("select field_value from staff_multi where field_name = 'access' and userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while ( my $ac = $sth->fetchrow ) {
    $access{$ac} = 1;
}


my $title = "$lex{Delete} $lex{Student} - IEP";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print "</head><body>\n";

print qq{[ <a href="$tchpage">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};

# Access Control
if ( not $access{IEP} ){
    print qq{<h3>No Access Allowed</h3>\n};
    print qq{</body></html>\n};
    exit;
}


if ( not $arr{page} ) {
    showStartPage();

} else {
    delete $arr{page};
    deleteStudent();
}



#----------------
sub showStartPage {
#----------------
    
    # Start the Form here.
    print qq{<form action="$self" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="page" value="1">\n};

    print qq{<input type="submit" value="$lex{Delete}">\n};
    
    print qq{<table border="1" cellpadding="3" cellspacing="0" style="text-align:left;">\n};
    print qq{<tr><th>$lex{Name} ($lex{studnum})</th><th>$lex{Birthdate}</th><th>$lex{Grade}</th></tr>\n};


    my $sth = $dbh->prepare("select * from iep_student order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	
	print qq{<tr><td class="la"><input type="checkbox" name="$r{studnum}" value="1">\n};	
	print qq{<b>$r{lastname}</b>, $r{firstname} ($r{studnum})\n};
	print qq{</td><td>$r{birthdate}</td><td class="cn">$r{grade}</td></tr>\n};

    }

    print qq{</table>};
    print qq{<input type="submit" value="$lex{Delete}">\n};
    print qq{</form>\n};
    print qq{</body></html>\n};

    exit;

} # end of showStartPage


#---------------
sub deleteStudent {
#----------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }

    my $sth = $dbh->prepare("select *  from iep_student where studnum = ?");
    
    my $sth1 = $dbh->prepare("delete from iep_evalmst where studnum = ?");
    my $sth2 = $dbh->prepare("delete from iep_eval where studnum = ?");
    my $sth3 = $dbh->prepare("delete from iep_student where studnum = ?");

    
    foreach my $studnum ( sort keys %arr ) {
	
	$sth->execute($studnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $ref = $sth->fetchrow_hashref;
	my %r = %$ref;

	# now delete
	$sth1->execute($studnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	$sth2->execute($studnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	$sth3->execute($studnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	
	print qq{<div>$r{firstname} $r{lastname} $lex{Deleted}</div>\n};

    }

    print qq{</body></html>\n};

    exit;

} # end of deleteStudent
    

