#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Special Needs Students' => 'Special Needs Students',
	   'Description' => 'Description',
	   'Name/ID' => 'Name/ID',
	   'Edit' => 'Edit',
	   'Error' => 'Error',
	   'BDate' => 'BDate',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'Studnum' => 'Studnum',
	   'ProvNum' => 'ProvNum',
	   'Designation' => 'Designation',
	   'Des Date' => 'Des Date',
	   'Medical' => 'Medical',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'History' => 'History',
	   'Please Log In' => 'Please Log In',

	   'Strengths' => 'Strengths',
	   'Challenges' => 'Challenges',
	   'Assessments' => 'Assessments',
	   'Additional' => 'Additional',
	   'Full View' => 'Full View',
	   'DDPF Level' => 'DDPF Level',

	   );

my $self = 'iepstuddeled.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};
my $fullview = $arr{fullview};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;


if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></body></html>\n";
    exit;

}


my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";



my $title = "$lex{Edit} $lex{Student} - IEP";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print "</head><body>\n";

print qq{[ <a href="$tchpage">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


# Full view form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"hidden\" name=\"fullview\" value=\"1\">\n";
print "<input type=\"submit\" value=\"$lex{'Full View'}\"></form>\n";


print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\" style=\"text-align:left;\">\n";
print "<tr><th>$lex{'Name/ID'}</th><th>$lex{Description}</th></tr>\n";


my $sth = $dbh->prepare("select * from iep_student order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


while ( my $ref = $sth->fetchrow_hashref ) {
    my %r = %$ref;
    # print "REF:$ref<br>\n";

    if ( not $fullview ){

	print "<tr><td>";

	print "<form action=\"iepstuded.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$r{id}\">\n";
	print "<input type=\"submit\" value=\"$lex{Edit}\">\n";
	print "</form>\n";

	print "<b>$r{lastname}</b>, $r{firstname} ($r{studnum})\n";
	print "</td><td>DOB:$r{birthdate} - $lex{Grade} $r{grade}</td></tr>\n";

    } else { # print complete records

        print "<tr><td valign=\"top\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" style=\"text-align:left;\">\n";
	print "<tr><td colspan=\"2\" align=\"center\"><b>$r{firstname} $r{lastname}</b></td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{BDate}. "</em></td><td>$r{birthdate}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Grade}. "</em></td><td>$r{grade}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{School}. "</em></td><td>$r{school}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Gender}. "</em></td><td>$r{sex}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Studnum}. "</em></td><td> $r{studnum}</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{ProvNum}. "</em></td><td> $r{provnum}</td></tr>\n";
	print "</table>\n";

	print "<form action=\"sped.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$r{id}\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\">\n";
	print "</form>\n";

	print "</td>\n";
	print "<td valign=\"top\"><table cellpadding=\"3\" style=\"text-align:left;\">\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Designation};
	print "</em></td><td>$r{designation}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'DDPF Level'};
	print "</em></td><td>$r{ddpflvl}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'Des Date'};
	print "</em></td><td>$r{desdate}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medical};
	print "</em></td><td>$r{medical}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medication};
	print "</em></td><td>$r{medication}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Equipment};
	print "</em></td><td>$r{equip}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Adaptations};
	print "</em></td><td>$r{adapt}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{History};
	print "</em></td><td>$r{history}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Strengths};
	print "</em></td><td>$r{strengths}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Challenges};
	print "</em></td><td>$r{challenges}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Assessments};
	print "</em></td><td>$r{assessments}</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Additional};
	print "</em></td><td>$r{additional}</td></tr>\n";

	print "</table></td></tr>\n";

    } # end of If/Else
}

print "</table></center></body></html>\n";
