#!/usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

my $schooldb = 'chiefnapew'; # the school field value in the special table.

my $iepdbase = 'iep2015';
my $iepuser = 'root';
my $ieppassword = 'sezme';



use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# Local Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# IEP Database
my $dsn1 = "DBI:$dbtype:dbname=$iepdbase";
my $dbh1 = DBI->connect($dsn1,$iepuser,$ieppassword);

# Get Students in this school
my $sth = $dbh1->prepare("select * from special where school = ?");
$sth->execute( $schooldb );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

while ( my $ref = $sth->fetchrow_hashref ) {
    my %r = %$ref;
    my $studnum = $r{studnum};
    delete $r{id}; # not needed.

    my (@fields, @values, @qst );
    foreach my $field ( sort keys %r ) {
	if ( $r{$field} ) {
	    push @fields, $field;
	    push @values, $r{$field};
	    push @qst, '?';
	}
    }

    my $fields = join(',', @fields);
    my $qst = join(',', @qst);

    my $sth1 = $dbh->prepare( "insert into iep_student ( $fields ) values ( $qst )" ); 
    $sth1->execute( @values );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    # Student Now Added.


    # Add Evaluation Masters
    my $sth2 = $dbh1->prepare("select * from evalmst where studnum = ?");
    $sth2->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    while ( my $emref = $sth2->fetchrow_hashref ) {
	my %em = %$emref;
	delete $em{id}; # not needed.

	my (@fields, @values, @qst );
	foreach my $field ( sort keys %em ) {
	    if ( $em{$field} ) {
		push @fields, $field;
		push @values, $em{$field};
		push @qst, '?';
	    }
	}

	my $fields = join(',', @fields);
	my $qst = join(',', @qst);

	my $sth3 = $dbh->prepare( "insert into iep_evalmst ( $fields ) values ( $qst )" ); 
	$sth3->execute( @values );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    } 	# Eval Masters Now Added.


}

